/* game.c generated by valac 0.44.0, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2009 Lubomir Rintel <lkundrak@v3.sk>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <math.h>
#include <float.h>
#include <string.h>

#define TYPE_BLOCK (block_get_type ())
#define BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLOCK, Block))
#define BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLOCK, BlockClass))
#define IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLOCK))
#define IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLOCK))
#define BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLOCK, BlockClass))

typedef struct _Block Block;
typedef struct _BlockClass BlockClass;
typedef struct _BlockPrivate BlockPrivate;
enum  {
	BLOCK_0_PROPERTY,
	BLOCK_NUM_PROPERTIES
};
static GParamSpec* block_properties[BLOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SHAPE (shape_get_type ())
#define SHAPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHAPE, Shape))
#define SHAPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHAPE, ShapeClass))
#define IS_SHAPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHAPE))
#define IS_SHAPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHAPE))
#define SHAPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHAPE, ShapeClass))

typedef struct _Shape Shape;
typedef struct _ShapeClass ShapeClass;
typedef struct _ShapePrivate ShapePrivate;
enum  {
	SHAPE_0_PROPERTY,
	SHAPE_NUM_PROPERTIES
};
static GParamSpec* shape_properties[SHAPE_NUM_PROPERTIES];

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_WIDTH_PROPERTY,
	GAME_HEIGHT_PROPERTY,
	GAME_LEVEL_PROPERTY,
	GAME_PAUSED_PROPERTY,
	GAME_SHADOW_Y_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
enum  {
	GAME_STARTED_SIGNAL,
	GAME_SHAPE_ADDED_SIGNAL,
	GAME_SHAPE_MOVED_SIGNAL,
	GAME_SHAPE_DROPPED_SIGNAL,
	GAME_SHAPE_ROTATED_SIGNAL,
	GAME_SHAPE_LANDED_SIGNAL,
	GAME_PAUSE_CHANGED_SIGNAL,
	GAME_COMPLETE_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};

struct _Block {
	GObject parent_instance;
	BlockPrivate * priv;
	gint x;
	gint y;
	gint color;
};

struct _BlockClass {
	GObjectClass parent_class;
};

struct _Shape {
	GObject parent_instance;
	ShapePrivate * priv;
	gint x;
	gint y;
	gint rotation;
	gint type;
	GList* blocks;
};

struct _ShapeClass {
	GObjectClass parent_class;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
	Shape* shape;
	Shape* next_shape;
	Block** blocks;
	gint blocks_length1;
	gint blocks_length2;
	gint n_lines_destroyed;
	gint score;
	gboolean game_over;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	gint starting_level;
	gboolean pick_difficult_blocks;
	gint fast_move_direction;
	guint fast_move_timeout;
	gboolean fast_forward;
	guint drop_timeout;
	gboolean has_started;
	gboolean _paused;
};

static gpointer block_parent_class = NULL;
static gpointer shape_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

#define NCOLORS 7
GType block_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Block, g_object_unref)
Block* block_copy (Block* self);
Block* block_new (void);
Block* block_construct (GType object_type);
static void block_finalize (GObject * obj);
GType shape_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Shape, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
Shape* shape_copy (Shape* self);
Shape* shape_new (void);
Shape* shape_construct (GType object_type);
static void shape_finalize (GObject * obj);
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
Game* game_new (gint lines,
                gint columns,
                gint starting_level,
                gint filled_lines,
                gint fill_prob,
                gboolean pick_difficult_blocks);
Game* game_construct (GType object_type,
                      gint lines,
                      gint columns,
                      gint starting_level,
                      gint filled_lines,
                      gint fill_prob,
                      gboolean pick_difficult_blocks);
gint game_get_height (Game* self);
gint game_get_width (Game* self);
static Shape* game_pick_random_shape (Game* self);
Game* game_copy (Game* self);
void game_start (Game* self);
static void game_add_shape (Game* self);
static void game_setup_drop_timer (Game* self);
gboolean game_move_left (Game* self);
static gboolean game_move_direction (Game* self,
                              gint direction);
gboolean game_move_right (Game* self);
gboolean game_stop_moving (Game* self);
gboolean game_rotate_left (Game* self);
static gboolean game_move_shape (Game* self,
                          gint x_step,
                          gint y_step,
                          gint r_step);
gboolean game_rotate_right (Game* self);
void game_set_fast_forward (Game* self,
                            gboolean enable);
void game_drop (Game* self);
static gboolean game_fall_timeout_cb (Game* self);
void game_stop (Game* self);
static gboolean game_move (Game* self);
static gboolean game_setup_fast_move_cb (Game* self);
static gboolean _game_setup_fast_move_cb_gsource_func (gpointer self);
static gboolean _game_move_gsource_func (gpointer self);
gint game_get_level (Game* self);
gboolean game_get_paused (Game* self);
static gboolean _game_fall_timeout_cb_gsource_func (gpointer self);
static void game_land_shape (Game* self);
static Shape** game_pick_difficult_shapes (Game* self,
                                    gint* result_length1);
static Shape* game_make_shape (Game* self,
                        gint type,
                        gint rotation);
static void game_rotate_shape (Game* self,
                        gint r_step);
void game_set_paused (Game* self,
                      gboolean value);
gint game_get_shadow_y (Game* self);
static void g_cclosure_user_marshal_VOID__POINTER_INT_POINTER (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const gint block_table[448] = {0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0};

Block*
block_copy (Block* self)
{
	Block* result = NULL;
	Block* b = NULL;
	Block* _tmp0_;
#line 181 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 183 "../src/game.vala"
	_tmp0_ = block_new ();
#line 183 "../src/game.vala"
	b = _tmp0_;
#line 184 "../src/game.vala"
	b->x = self->x;
#line 185 "../src/game.vala"
	b->y = self->y;
#line 186 "../src/game.vala"
	b->color = self->color;
#line 187 "../src/game.vala"
	result = b;
#line 187 "../src/game.vala"
	return result;
#line 264 "game.c"
}

Block*
block_construct (GType object_type)
{
	Block * self = NULL;
#line 172 "../src/game.vala"
	self = (Block*) g_object_new (object_type, NULL);
#line 172 "../src/game.vala"
	return self;
#line 275 "game.c"
}

Block*
block_new (void)
{
#line 172 "../src/game.vala"
	return block_construct (TYPE_BLOCK);
#line 283 "game.c"
}

static void
block_class_init (BlockClass * klass,
                  gpointer klass_data)
{
#line 172 "../src/game.vala"
	block_parent_class = g_type_class_peek_parent (klass);
#line 172 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = block_finalize;
#line 294 "game.c"
}

static void
block_instance_init (Block * self,
                     gpointer klass)
{
}

static void
block_finalize (GObject * obj)
{
	Block * self;
#line 172 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLOCK, Block);
#line 172 "../src/game.vala"
	G_OBJECT_CLASS (block_parent_class)->finalize (obj);
#line 311 "game.c"
}

GType
block_get_type (void)
{
	static volatile gsize block_type_id__volatile = 0;
	if (g_once_init_enter (&block_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BlockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Block), 0, (GInstanceInitFunc) block_instance_init, NULL };
		GType block_type_id;
		block_type_id = g_type_register_static (G_TYPE_OBJECT, "Block", &g_define_type_info, 0);
		g_once_init_leave (&block_type_id__volatile, block_type_id);
	}
	return block_type_id__volatile;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 204 "../src/game.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 332 "game.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 204 "../src/game.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 340 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 213 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 348 "game.c"
}

Shape*
shape_copy (Shape* self)
{
	Shape* result = NULL;
	Shape* s = NULL;
	Shape* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp2_;
	Shape* _tmp3_;
	Shape* _tmp4_;
	GList* _tmp5_;
#line 206 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/game.vala"
	_tmp0_ = shape_new ();
#line 208 "../src/game.vala"
	s = _tmp0_;
#line 209 "../src/game.vala"
	_tmp1_ = s;
#line 209 "../src/game.vala"
	_tmp1_->x = self->x;
#line 210 "../src/game.vala"
	_tmp2_ = s;
#line 210 "../src/game.vala"
	_tmp2_->y = self->y;
#line 211 "../src/game.vala"
	_tmp3_ = s;
#line 211 "../src/game.vala"
	_tmp3_->rotation = self->rotation;
#line 212 "../src/game.vala"
	_tmp4_ = s;
#line 212 "../src/game.vala"
	_tmp4_->type = self->type;
#line 213 "../src/game.vala"
	_tmp5_ = self->blocks;
#line 386 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 213 "../src/game.vala"
		b_collection = _tmp5_;
#line 213 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 394 "game.c"
			Block* _tmp6_;
			Block* b = NULL;
#line 213 "../src/game.vala"
			_tmp6_ = _g_object_ref0 ((Block*) b_it->data);
#line 213 "../src/game.vala"
			b = _tmp6_;
#line 401 "game.c"
			{
				Shape* _tmp7_;
				Block* _tmp8_;
				Block* _tmp9_;
#line 214 "../src/game.vala"
				_tmp7_ = s;
#line 214 "../src/game.vala"
				_tmp8_ = b;
#line 214 "../src/game.vala"
				_tmp9_ = block_copy (_tmp8_);
#line 214 "../src/game.vala"
				_tmp7_->blocks = g_list_append (_tmp7_->blocks, _tmp9_);
#line 213 "../src/game.vala"
				_g_object_unref0 (b);
#line 416 "game.c"
			}
		}
	}
#line 215 "../src/game.vala"
	result = s;
#line 215 "../src/game.vala"
	return result;
#line 424 "game.c"
}

Shape*
shape_construct (GType object_type)
{
	Shape * self = NULL;
#line 191 "../src/game.vala"
	self = (Shape*) g_object_new (object_type, NULL);
#line 191 "../src/game.vala"
	return self;
#line 435 "game.c"
}

Shape*
shape_new (void)
{
#line 191 "../src/game.vala"
	return shape_construct (TYPE_SHAPE);
#line 443 "game.c"
}

static void
shape_class_init (ShapeClass * klass,
                  gpointer klass_data)
{
#line 191 "../src/game.vala"
	shape_parent_class = g_type_class_peek_parent (klass);
#line 191 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = shape_finalize;
#line 454 "game.c"
}

static void
shape_instance_init (Shape * self,
                     gpointer klass)
{
#line 204 "../src/game.vala"
	self->blocks = NULL;
#line 463 "game.c"
}

static void
shape_finalize (GObject * obj)
{
	Shape * self;
#line 191 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHAPE, Shape);
#line 204 "../src/game.vala"
	(self->blocks == NULL) ? NULL : (self->blocks = (_g_list_free__g_object_unref0_ (self->blocks), NULL));
#line 191 "../src/game.vala"
	G_OBJECT_CLASS (shape_parent_class)->finalize (obj);
#line 476 "game.c"
}

GType
shape_get_type (void)
{
	static volatile gsize shape_type_id__volatile = 0;
	if (g_once_init_enter (&shape_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ShapeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) shape_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Shape), 0, (GInstanceInitFunc) shape_instance_init, NULL };
		GType shape_type_id;
		shape_type_id = g_type_register_static (G_TYPE_OBJECT, "Shape", &g_define_type_info, 0);
		g_once_init_leave (&shape_type_id__volatile, shape_type_id);
	}
	return shape_type_id__volatile;
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gint lines,
                gint columns,
                gint starting_level,
                gint filled_lines,
                gint fill_prob,
                gboolean pick_difficult_blocks)
{
	Game * self = NULL;
	Block** _tmp0_;
#line 305 "../src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 307 "../src/game.vala"
	self->priv->starting_level = starting_level;
#line 308 "../src/game.vala"
	self->priv->pick_difficult_blocks = pick_difficult_blocks;
#line 310 "../src/game.vala"
	_tmp0_ = g_new0 (Block*, (columns * lines) + 1);
#line 310 "../src/game.vala"
	self->blocks = (_vala_array_free (self->blocks, self->blocks_length1 * self->blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 310 "../src/game.vala"
	self->blocks = _tmp0_;
#line 310 "../src/game.vala"
	self->blocks_length1 = columns;
#line 310 "../src/game.vala"
	self->blocks_length2 = lines;
#line 525 "game.c"
	{
		gint y = 0;
#line 312 "../src/game.vala"
		y = 0;
#line 530 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 312 "../src/game.vala"
			_tmp1_ = TRUE;
#line 312 "../src/game.vala"
			while (TRUE) {
#line 537 "game.c"
				gint _tmp3_;
				gint _tmp4_;
				gint32 blank = 0;
				gint _tmp5_;
				gint _tmp6_;
#line 312 "../src/game.vala"
				if (!_tmp1_) {
#line 545 "game.c"
					gint _tmp2_;
#line 312 "../src/game.vala"
					_tmp2_ = y;
#line 312 "../src/game.vala"
					y = _tmp2_ + 1;
#line 551 "game.c"
				}
#line 312 "../src/game.vala"
				_tmp1_ = FALSE;
#line 312 "../src/game.vala"
				_tmp3_ = game_get_height (self);
#line 312 "../src/game.vala"
				_tmp4_ = _tmp3_;
#line 312 "../src/game.vala"
				if (!(y < _tmp4_)) {
#line 312 "../src/game.vala"
					break;
#line 563 "game.c"
				}
#line 315 "../src/game.vala"
				_tmp5_ = game_get_width (self);
#line 315 "../src/game.vala"
				_tmp6_ = _tmp5_;
#line 315 "../src/game.vala"
				blank = g_random_int_range ((gint32) 0, (gint32) _tmp6_);
#line 571 "game.c"
				{
					gint x = 0;
#line 317 "../src/game.vala"
					x = 0;
#line 576 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 317 "../src/game.vala"
						_tmp7_ = TRUE;
#line 317 "../src/game.vala"
						while (TRUE) {
#line 583 "game.c"
							gint _tmp9_;
							gint _tmp10_;
							gboolean _tmp11_ = FALSE;
							gboolean _tmp12_ = FALSE;
							gint _tmp13_;
							gint _tmp14_;
#line 317 "../src/game.vala"
							if (!_tmp7_) {
#line 592 "game.c"
								gint _tmp8_;
#line 317 "../src/game.vala"
								_tmp8_ = x;
#line 317 "../src/game.vala"
								x = _tmp8_ + 1;
#line 598 "game.c"
							}
#line 317 "../src/game.vala"
							_tmp7_ = FALSE;
#line 317 "../src/game.vala"
							_tmp9_ = game_get_width (self);
#line 317 "../src/game.vala"
							_tmp10_ = _tmp9_;
#line 317 "../src/game.vala"
							if (!(x < _tmp10_)) {
#line 317 "../src/game.vala"
								break;
#line 610 "game.c"
							}
#line 319 "../src/game.vala"
							_tmp13_ = game_get_height (self);
#line 319 "../src/game.vala"
							_tmp14_ = _tmp13_;
#line 319 "../src/game.vala"
							if (y >= (_tmp14_ - filled_lines)) {
#line 319 "../src/game.vala"
								_tmp12_ = x != ((gint) blank);
#line 620 "game.c"
							} else {
#line 319 "../src/game.vala"
								_tmp12_ = FALSE;
#line 624 "game.c"
							}
#line 319 "../src/game.vala"
							if (_tmp12_) {
#line 319 "../src/game.vala"
								_tmp11_ = g_random_int_range ((gint32) 0, (gint32) 10) < ((gint32) fill_prob);
#line 630 "game.c"
							} else {
#line 319 "../src/game.vala"
								_tmp11_ = FALSE;
#line 634 "game.c"
							}
#line 319 "../src/game.vala"
							if (_tmp11_) {
#line 638 "game.c"
								Block** _tmp15_;
								gint _tmp15__length1;
								gint _tmp15__length2;
								Block* _tmp16_;
								Block** _tmp17_;
								gint _tmp17__length1;
								gint _tmp17__length2;
								Block* _tmp18_;
								Block** _tmp19_;
								gint _tmp19__length1;
								gint _tmp19__length2;
								Block* _tmp20_;
								Block** _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								Block* _tmp22_;
#line 321 "../src/game.vala"
								_tmp15_ = self->blocks;
#line 321 "../src/game.vala"
								_tmp15__length1 = self->blocks_length1;
#line 321 "../src/game.vala"
								_tmp15__length2 = self->blocks_length2;
#line 321 "../src/game.vala"
								_tmp16_ = block_new ();
#line 321 "../src/game.vala"
								_g_object_unref0 (_tmp15_[(x * _tmp15__length2) + y]);
#line 321 "../src/game.vala"
								_tmp15_[(x * _tmp15__length2) + y] = _tmp16_;
#line 322 "../src/game.vala"
								_tmp17_ = self->blocks;
#line 322 "../src/game.vala"
								_tmp17__length1 = self->blocks_length1;
#line 322 "../src/game.vala"
								_tmp17__length2 = self->blocks_length2;
#line 322 "../src/game.vala"
								_tmp18_ = _tmp17_[(x * _tmp17__length2) + y];
#line 322 "../src/game.vala"
								_tmp18_->x = x;
#line 323 "../src/game.vala"
								_tmp19_ = self->blocks;
#line 323 "../src/game.vala"
								_tmp19__length1 = self->blocks_length1;
#line 323 "../src/game.vala"
								_tmp19__length2 = self->blocks_length2;
#line 323 "../src/game.vala"
								_tmp20_ = _tmp19_[(x * _tmp19__length2) + y];
#line 323 "../src/game.vala"
								_tmp20_->y = y;
#line 324 "../src/game.vala"
								_tmp21_ = self->blocks;
#line 324 "../src/game.vala"
								_tmp21__length1 = self->blocks_length1;
#line 324 "../src/game.vala"
								_tmp21__length2 = self->blocks_length2;
#line 324 "../src/game.vala"
								_tmp22_ = _tmp21_[(x * _tmp21__length2) + y];
#line 324 "../src/game.vala"
								_tmp22_->color = (gint) g_random_int_range ((gint32) 0, (gint32) NCOLORS);
#line 697 "game.c"
							} else {
								Block** _tmp23_;
								gint _tmp23__length1;
								gint _tmp23__length2;
#line 327 "../src/game.vala"
								_tmp23_ = self->blocks;
#line 327 "../src/game.vala"
								_tmp23__length1 = self->blocks_length1;
#line 327 "../src/game.vala"
								_tmp23__length2 = self->blocks_length2;
#line 327 "../src/game.vala"
								_g_object_unref0 (_tmp23_[(x * _tmp23__length2) + y]);
#line 327 "../src/game.vala"
								_tmp23_[(x * _tmp23__length2) + y] = NULL;
#line 712 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 331 "../src/game.vala"
	if (!pick_difficult_blocks) {
#line 722 "game.c"
		Shape* _tmp24_;
#line 332 "../src/game.vala"
		_tmp24_ = game_pick_random_shape (self);
#line 332 "../src/game.vala"
		_g_object_unref0 (self->next_shape);
#line 332 "../src/game.vala"
		self->next_shape = _tmp24_;
#line 730 "game.c"
	}
#line 305 "../src/game.vala"
	return self;
#line 734 "game.c"
}

Game*
game_new (gint lines,
          gint columns,
          gint starting_level,
          gint filled_lines,
          gint fill_prob,
          gboolean pick_difficult_blocks)
{
#line 305 "../src/game.vala"
	return game_construct (TYPE_GAME, lines, columns, starting_level, filled_lines, fill_prob, pick_difficult_blocks);
#line 747 "game.c"
}

Game*
game_copy (Game* self)
{
	Game* result = NULL;
	Game* g = NULL;
	Game* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp5_;
	Game* _tmp24_;
	Game* _tmp25_;
	Game* _tmp26_;
	Game* _tmp27_;
	Game* _tmp28_;
	Game* _tmp29_;
	Game* _tmp30_;
	Game* _tmp31_;
	Game* _tmp32_;
#line 335 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "../src/game.vala"
	_tmp0_ = game_new (20, 14, 1, 0, 5, FALSE);
#line 337 "../src/game.vala"
	g = _tmp0_;
#line 338 "../src/game.vala"
	_tmp1_ = self->shape;
#line 338 "../src/game.vala"
	if (_tmp1_ != NULL) {
#line 777 "game.c"
		Game* _tmp2_;
		Shape* _tmp3_;
		Shape* _tmp4_;
#line 339 "../src/game.vala"
		_tmp2_ = g;
#line 339 "../src/game.vala"
		_tmp3_ = self->shape;
#line 339 "../src/game.vala"
		_tmp4_ = shape_copy (_tmp3_);
#line 339 "../src/game.vala"
		_g_object_unref0 (_tmp2_->shape);
#line 339 "../src/game.vala"
		_tmp2_->shape = _tmp4_;
#line 791 "game.c"
	}
#line 340 "../src/game.vala"
	_tmp5_ = self->next_shape;
#line 340 "../src/game.vala"
	if (_tmp5_ != NULL) {
#line 797 "game.c"
		Game* _tmp6_;
		Shape* _tmp7_;
		Shape* _tmp8_;
#line 341 "../src/game.vala"
		_tmp6_ = g;
#line 341 "../src/game.vala"
		_tmp7_ = self->next_shape;
#line 341 "../src/game.vala"
		_tmp8_ = shape_copy (_tmp7_);
#line 341 "../src/game.vala"
		_g_object_unref0 (_tmp6_->next_shape);
#line 341 "../src/game.vala"
		_tmp6_->next_shape = _tmp8_;
#line 811 "game.c"
	}
	{
		gint x = 0;
#line 342 "../src/game.vala"
		x = 0;
#line 817 "game.c"
		{
			gboolean _tmp9_ = FALSE;
#line 342 "../src/game.vala"
			_tmp9_ = TRUE;
#line 342 "../src/game.vala"
			while (TRUE) {
#line 824 "game.c"
				gint _tmp11_;
				gint _tmp12_;
#line 342 "../src/game.vala"
				if (!_tmp9_) {
#line 829 "game.c"
					gint _tmp10_;
#line 342 "../src/game.vala"
					_tmp10_ = x;
#line 342 "../src/game.vala"
					x = _tmp10_ + 1;
#line 835 "game.c"
				}
#line 342 "../src/game.vala"
				_tmp9_ = FALSE;
#line 342 "../src/game.vala"
				_tmp11_ = game_get_width (self);
#line 342 "../src/game.vala"
				_tmp12_ = _tmp11_;
#line 342 "../src/game.vala"
				if (!(x < _tmp12_)) {
#line 342 "../src/game.vala"
					break;
#line 847 "game.c"
				}
				{
					gint y = 0;
#line 344 "../src/game.vala"
					y = 0;
#line 853 "game.c"
					{
						gboolean _tmp13_ = FALSE;
#line 344 "../src/game.vala"
						_tmp13_ = TRUE;
#line 344 "../src/game.vala"
						while (TRUE) {
#line 860 "game.c"
							gint _tmp15_;
							gint _tmp16_;
							Block** _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							Block* _tmp18_;
#line 344 "../src/game.vala"
							if (!_tmp13_) {
#line 869 "game.c"
								gint _tmp14_;
#line 344 "../src/game.vala"
								_tmp14_ = y;
#line 344 "../src/game.vala"
								y = _tmp14_ + 1;
#line 875 "game.c"
							}
#line 344 "../src/game.vala"
							_tmp13_ = FALSE;
#line 344 "../src/game.vala"
							_tmp15_ = game_get_height (self);
#line 344 "../src/game.vala"
							_tmp16_ = _tmp15_;
#line 344 "../src/game.vala"
							if (!(y < _tmp16_)) {
#line 344 "../src/game.vala"
								break;
#line 887 "game.c"
							}
#line 346 "../src/game.vala"
							_tmp17_ = self->blocks;
#line 346 "../src/game.vala"
							_tmp17__length1 = self->blocks_length1;
#line 346 "../src/game.vala"
							_tmp17__length2 = self->blocks_length2;
#line 346 "../src/game.vala"
							_tmp18_ = _tmp17_[(x * _tmp17__length2) + y];
#line 346 "../src/game.vala"
							if (_tmp18_ != NULL) {
#line 899 "game.c"
								Game* _tmp19_;
								Block** _tmp20_;
								gint _tmp20__length1;
								gint _tmp20__length2;
								Block** _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								Block* _tmp22_;
								Block* _tmp23_;
#line 347 "../src/game.vala"
								_tmp19_ = g;
#line 347 "../src/game.vala"
								_tmp20_ = _tmp19_->blocks;
#line 347 "../src/game.vala"
								_tmp20__length1 = _tmp19_->blocks_length1;
#line 347 "../src/game.vala"
								_tmp20__length2 = _tmp19_->blocks_length2;
#line 347 "../src/game.vala"
								_tmp21_ = self->blocks;
#line 347 "../src/game.vala"
								_tmp21__length1 = self->blocks_length1;
#line 347 "../src/game.vala"
								_tmp21__length2 = self->blocks_length2;
#line 347 "../src/game.vala"
								_tmp22_ = _tmp21_[(x * _tmp21__length2) + y];
#line 347 "../src/game.vala"
								_tmp23_ = block_copy (_tmp22_);
#line 347 "../src/game.vala"
								_g_object_unref0 (_tmp20_[(x * _tmp20__length2) + y]);
#line 347 "../src/game.vala"
								_tmp20_[(x * _tmp20__length2) + y] = _tmp23_;
#line 931 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 350 "../src/game.vala"
	_tmp24_ = g;
#line 350 "../src/game.vala"
	_tmp24_->n_lines_destroyed = self->n_lines_destroyed;
#line 351 "../src/game.vala"
	_tmp25_ = g;
#line 351 "../src/game.vala"
	_tmp25_->score = self->score;
#line 352 "../src/game.vala"
	_tmp26_ = g;
#line 352 "../src/game.vala"
	_tmp26_->priv->starting_level = self->priv->starting_level;
#line 353 "../src/game.vala"
	_tmp27_ = g;
#line 353 "../src/game.vala"
	_tmp27_->priv->pick_difficult_blocks = self->priv->pick_difficult_blocks;
#line 354 "../src/game.vala"
	_tmp28_ = g;
#line 354 "../src/game.vala"
	_tmp28_->priv->fast_move_direction = self->priv->fast_move_direction;
#line 355 "../src/game.vala"
	_tmp29_ = g;
#line 355 "../src/game.vala"
	_tmp29_->priv->fast_forward = self->priv->fast_forward;
#line 356 "../src/game.vala"
	_tmp30_ = g;
#line 356 "../src/game.vala"
	_tmp30_->priv->has_started = self->priv->has_started;
#line 357 "../src/game.vala"
	_tmp31_ = g;
#line 357 "../src/game.vala"
	_tmp31_->priv->_paused = self->priv->_paused;
#line 358 "../src/game.vala"
	_tmp32_ = g;
#line 358 "../src/game.vala"
	_tmp32_->game_over = self->game_over;
#line 360 "../src/game.vala"
	result = g;
#line 360 "../src/game.vala"
	return result;
#line 979 "game.c"
}

void
game_start (Game* self)
{
#line 363 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/game.vala"
	self->priv->has_started = TRUE;
#line 366 "../src/game.vala"
	game_add_shape (self);
#line 367 "../src/game.vala"
	game_setup_drop_timer (self);
#line 368 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_STARTED_SIGNAL], 0);
#line 369 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_PAUSE_CHANGED_SIGNAL], 0);
#line 997 "game.c"
}

gboolean
game_move_left (Game* self)
{
	gboolean result = FALSE;
#line 372 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 374 "../src/game.vala"
	result = game_move_direction (self, -1);
#line 374 "../src/game.vala"
	return result;
#line 1010 "game.c"
}

gboolean
game_move_right (Game* self)
{
	gboolean result = FALSE;
#line 377 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 379 "../src/game.vala"
	result = game_move_direction (self, 1);
#line 379 "../src/game.vala"
	return result;
#line 1023 "game.c"
}

gboolean
game_stop_moving (Game* self)
{
	gboolean result = FALSE;
#line 382 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 384 "../src/game.vala"
	if (self->game_over) {
#line 385 "../src/game.vala"
		result = FALSE;
#line 385 "../src/game.vala"
		return result;
#line 1038 "game.c"
	}
#line 387 "../src/game.vala"
	if (self->priv->fast_move_timeout != ((guint) 0)) {
#line 388 "../src/game.vala"
		g_source_remove (self->priv->fast_move_timeout);
#line 1044 "game.c"
	}
#line 389 "../src/game.vala"
	self->priv->fast_move_timeout = (guint) 0;
#line 390 "../src/game.vala"
	self->priv->fast_move_direction = 0;
#line 392 "../src/game.vala"
	result = TRUE;
#line 392 "../src/game.vala"
	return result;
#line 1054 "game.c"
}

gboolean
game_rotate_left (Game* self)
{
	gboolean result = FALSE;
#line 395 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 397 "../src/game.vala"
	result = game_move_shape (self, 0, 0, 1);
#line 397 "../src/game.vala"
	return result;
#line 1067 "game.c"
}

gboolean
game_rotate_right (Game* self)
{
	gboolean result = FALSE;
#line 400 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 402 "../src/game.vala"
	result = game_move_shape (self, 0, 0, -1);
#line 402 "../src/game.vala"
	return result;
#line 1080 "game.c"
}

void
game_set_fast_forward (Game* self,
                       gboolean enable)
{
	gboolean _tmp0_ = FALSE;
#line 405 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 407 "../src/game.vala"
	if (self->priv->fast_forward == enable) {
#line 407 "../src/game.vala"
		_tmp0_ = TRUE;
#line 1094 "game.c"
	} else {
#line 407 "../src/game.vala"
		_tmp0_ = self->game_over;
#line 1098 "game.c"
	}
#line 407 "../src/game.vala"
	if (_tmp0_) {
#line 408 "../src/game.vala"
		return;
#line 1104 "game.c"
	}
#line 409 "../src/game.vala"
	if (enable) {
#line 410 "../src/game.vala"
		if (!game_move_shape (self, 0, 1, 0)) {
#line 411 "../src/game.vala"
			return;
#line 1112 "game.c"
		}
	}
#line 412 "../src/game.vala"
	self->priv->fast_forward = enable;
#line 413 "../src/game.vala"
	game_setup_drop_timer (self);
#line 1119 "game.c"
}

void
game_drop (Game* self)
{
	Shape* _tmp0_;
#line 416 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 418 "../src/game.vala"
	_tmp0_ = self->shape;
#line 418 "../src/game.vala"
	if (_tmp0_ == NULL) {
#line 419 "../src/game.vala"
		return;
#line 1134 "game.c"
	}
#line 421 "../src/game.vala"
	while (TRUE) {
#line 421 "../src/game.vala"
		if (!game_move_shape (self, 0, 1, 0)) {
#line 421 "../src/game.vala"
			break;
#line 1142 "game.c"
		}
	}
#line 422 "../src/game.vala"
	game_fall_timeout_cb (self);
#line 1147 "game.c"
}

void
game_stop (Game* self)
{
#line 425 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/game.vala"
	if (self->priv->drop_timeout != ((guint) 0)) {
#line 428 "../src/game.vala"
		g_source_remove (self->priv->drop_timeout);
#line 1159 "game.c"
	}
}

static gboolean
_game_setup_fast_move_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = game_setup_fast_move_cb ((Game*) self);
#line 445 "../src/game.vala"
	return result;
#line 1170 "game.c"
}

static gboolean
game_move_direction (Game* self,
                     gint direction)
{
	gboolean result = FALSE;
#line 431 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 433 "../src/game.vala"
	if (self->game_over) {
#line 434 "../src/game.vala"
		result = FALSE;
#line 434 "../src/game.vala"
		return result;
#line 1186 "game.c"
	}
#line 435 "../src/game.vala"
	if (self->priv->fast_move_direction == direction) {
#line 436 "../src/game.vala"
		result = TRUE;
#line 436 "../src/game.vala"
		return result;
#line 1194 "game.c"
	}
#line 438 "../src/game.vala"
	if (self->priv->fast_move_timeout != ((guint) 0)) {
#line 439 "../src/game.vala"
		g_source_remove (self->priv->fast_move_timeout);
#line 1200 "game.c"
	}
#line 440 "../src/game.vala"
	self->priv->fast_move_timeout = (guint) 0;
#line 441 "../src/game.vala"
	self->priv->fast_move_direction = direction;
#line 442 "../src/game.vala"
	if (!game_move (self)) {
#line 443 "../src/game.vala"
		result = FALSE;
#line 443 "../src/game.vala"
		return result;
#line 1212 "game.c"
	}
#line 445 "../src/game.vala"
	self->priv->fast_move_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _game_setup_fast_move_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 447 "../src/game.vala"
	result = TRUE;
#line 447 "../src/game.vala"
	return result;
#line 1220 "game.c"
}

static gboolean
_game_move_gsource_func (gpointer self)
{
	gboolean result;
	result = game_move ((Game*) self);
#line 454 "../src/game.vala"
	return result;
#line 1230 "game.c"
}

static gboolean
game_setup_fast_move_cb (Game* self)
{
	gboolean result = FALSE;
#line 450 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 452 "../src/game.vala"
	if (!game_move (self)) {
#line 453 "../src/game.vala"
		result = FALSE;
#line 453 "../src/game.vala"
		return result;
#line 1245 "game.c"
	}
#line 454 "../src/game.vala"
	self->priv->fast_move_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 40, _game_move_gsource_func, g_object_ref (self), g_object_unref);
#line 456 "../src/game.vala"
	result = FALSE;
#line 456 "../src/game.vala"
	return result;
#line 1253 "game.c"
}

static gboolean
game_move (Game* self)
{
	gboolean result = FALSE;
#line 459 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 461 "../src/game.vala"
	if (!game_move_shape (self, self->priv->fast_move_direction, 0, 0)) {
#line 463 "../src/game.vala"
		self->priv->fast_move_timeout = (guint) 0;
#line 464 "../src/game.vala"
		self->priv->fast_move_direction = 0;
#line 466 "../src/game.vala"
		result = FALSE;
#line 466 "../src/game.vala"
		return result;
#line 1272 "game.c"
	}
#line 469 "../src/game.vala"
	result = TRUE;
#line 469 "../src/game.vala"
	return result;
#line 1278 "game.c"
}

static gboolean
_game_fall_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = game_fall_timeout_cb ((Game*) self);
#line 485 "../src/game.vala"
	return result;
#line 1288 "game.c"
}

static void
game_setup_drop_timer (Game* self)
{
	gint timestep = 0;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 472 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/game.vala"
	_tmp0_ = game_get_level (self);
#line 474 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 474 "../src/game.vala"
	timestep = (gint) round (80 + (800.0 * pow (0.75, (gdouble) (_tmp1_ - 1))));
#line 475 "../src/game.vala"
	timestep = MAX (10, timestep);
#line 478 "../src/game.vala"
	if (self->priv->fast_forward) {
#line 479 "../src/game.vala"
		timestep = 80;
#line 1313 "game.c"
	}
#line 481 "../src/game.vala"
	if (self->priv->drop_timeout != ((guint) 0)) {
#line 482 "../src/game.vala"
		g_source_remove (self->priv->drop_timeout);
#line 1319 "game.c"
	}
#line 483 "../src/game.vala"
	self->priv->drop_timeout = (guint) 0;
#line 484 "../src/game.vala"
	_tmp2_ = game_get_paused (self);
#line 484 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 484 "../src/game.vala"
	if (!_tmp3_) {
#line 485 "../src/game.vala"
		self->priv->drop_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) timestep, _game_fall_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1331 "game.c"
	}
}

static gboolean
game_fall_timeout_cb (Game* self)
{
	gboolean result = FALSE;
#line 488 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 491 "../src/game.vala"
	if (!game_move_shape (self, 0, 1, 0)) {
#line 494 "../src/game.vala"
		game_land_shape (self);
#line 497 "../src/game.vala"
		game_add_shape (self);
#line 1347 "game.c"
	}
#line 500 "../src/game.vala"
	result = TRUE;
#line 500 "../src/game.vala"
	return result;
#line 1353 "game.c"
}

static void
game_add_shape (Game* self)
{
	Shape* _tmp10_;
	GList* _tmp11_;
#line 503 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 505 "../src/game.vala"
	if (self->priv->pick_difficult_blocks) {
#line 1365 "game.c"
		Shape** difficult_shapes = NULL;
		gint _tmp0_ = 0;
		Shape** _tmp1_;
		gint difficult_shapes_length1;
		gint _difficult_shapes_size_;
		Shape** _tmp2_;
		gint _tmp2__length1;
		Shape* _tmp3_;
		Shape* _tmp4_;
		Shape** _tmp5_;
		gint _tmp5__length1;
		Shape* _tmp6_;
		Shape* _tmp7_;
#line 506 "../src/game.vala"
		_tmp1_ = game_pick_difficult_shapes (self, &_tmp0_);
#line 506 "../src/game.vala"
		difficult_shapes = _tmp1_;
#line 506 "../src/game.vala"
		difficult_shapes_length1 = _tmp0_;
#line 506 "../src/game.vala"
		_difficult_shapes_size_ = difficult_shapes_length1;
#line 507 "../src/game.vala"
		_tmp2_ = difficult_shapes;
#line 507 "../src/game.vala"
		_tmp2__length1 = difficult_shapes_length1;
#line 507 "../src/game.vala"
		_tmp3_ = _tmp2_[0];
#line 507 "../src/game.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 507 "../src/game.vala"
		_g_object_unref0 (self->shape);
#line 507 "../src/game.vala"
		self->shape = _tmp4_;
#line 508 "../src/game.vala"
		_tmp5_ = difficult_shapes;
#line 508 "../src/game.vala"
		_tmp5__length1 = difficult_shapes_length1;
#line 508 "../src/game.vala"
		_tmp6_ = _tmp5_[1];
#line 508 "../src/game.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 508 "../src/game.vala"
		_g_object_unref0 (self->next_shape);
#line 508 "../src/game.vala"
		self->next_shape = _tmp7_;
#line 505 "../src/game.vala"
		difficult_shapes = (_vala_array_free (difficult_shapes, difficult_shapes_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1413 "game.c"
	} else {
		Shape* _tmp8_;
		Shape* _tmp9_;
#line 512 "../src/game.vala"
		_tmp8_ = self->next_shape;
#line 512 "../src/game.vala"
		self->next_shape = NULL;
#line 512 "../src/game.vala"
		_g_object_unref0 (self->shape);
#line 512 "../src/game.vala"
		self->shape = _tmp8_;
#line 513 "../src/game.vala"
		_tmp9_ = game_pick_random_shape (self);
#line 513 "../src/game.vala"
		_g_object_unref0 (self->next_shape);
#line 513 "../src/game.vala"
		self->next_shape = _tmp9_;
#line 1431 "game.c"
	}
#line 516 "../src/game.vala"
	_tmp10_ = self->shape;
#line 516 "../src/game.vala"
	_tmp11_ = _tmp10_->blocks;
#line 1437 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 516 "../src/game.vala"
		b_collection = _tmp11_;
#line 516 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 1445 "game.c"
			Block* _tmp12_;
			Block* b = NULL;
#line 516 "../src/game.vala"
			_tmp12_ = _g_object_ref0 ((Block*) b_it->data);
#line 516 "../src/game.vala"
			b = _tmp12_;
#line 1452 "game.c"
			{
				gint x = 0;
				Shape* _tmp13_;
				Block* _tmp14_;
				gint y = 0;
				Shape* _tmp15_;
				Block* _tmp16_;
				gboolean _tmp17_ = FALSE;
#line 518 "../src/game.vala"
				_tmp13_ = self->shape;
#line 518 "../src/game.vala"
				_tmp14_ = b;
#line 518 "../src/game.vala"
				x = _tmp13_->x + _tmp14_->x;
#line 519 "../src/game.vala"
				_tmp15_ = self->shape;
#line 519 "../src/game.vala"
				_tmp16_ = b;
#line 519 "../src/game.vala"
				y = _tmp15_->y + _tmp16_->y;
#line 522 "../src/game.vala"
				if (y >= 0) {
#line 1475 "game.c"
					Block** _tmp18_;
					gint _tmp18__length1;
					gint _tmp18__length2;
					Block* _tmp19_;
#line 522 "../src/game.vala"
					_tmp18_ = self->blocks;
#line 522 "../src/game.vala"
					_tmp18__length1 = self->blocks_length1;
#line 522 "../src/game.vala"
					_tmp18__length2 = self->blocks_length2;
#line 522 "../src/game.vala"
					_tmp19_ = _tmp18_[(x * _tmp18__length2) + y];
#line 522 "../src/game.vala"
					_tmp17_ = _tmp19_ != NULL;
#line 1490 "game.c"
				} else {
#line 522 "../src/game.vala"
					_tmp17_ = FALSE;
#line 1494 "game.c"
				}
#line 522 "../src/game.vala"
				if (_tmp17_) {
#line 526 "../src/game.vala"
					if (self->priv->drop_timeout != ((guint) 0)) {
#line 527 "../src/game.vala"
						g_source_remove (self->priv->drop_timeout);
#line 1502 "game.c"
					}
#line 528 "../src/game.vala"
					self->priv->drop_timeout = (guint) 0;
#line 529 "../src/game.vala"
					_g_object_unref0 (self->shape);
#line 529 "../src/game.vala"
					self->shape = NULL;
#line 530 "../src/game.vala"
					self->game_over = TRUE;
#line 531 "../src/game.vala"
					g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
#line 532 "../src/game.vala"
					_g_object_unref0 (b);
#line 532 "../src/game.vala"
					return;
#line 1518 "game.c"
				}
#line 516 "../src/game.vala"
				_g_object_unref0 (b);
#line 1522 "game.c"
			}
		}
	}
#line 536 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_SHAPE_ADDED_SIGNAL], 0);
#line 1528 "game.c"
}

static Shape*
game_pick_random_shape (Game* self)
{
	Shape* result = NULL;
	Shape* _tmp0_;
#line 539 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 541 "../src/game.vala"
	_tmp0_ = game_make_shape (self, (gint) g_random_int_range ((gint32) 0, (gint32) NCOLORS), (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 541 "../src/game.vala"
	result = _tmp0_;
#line 541 "../src/game.vala"
	return result;
#line 1544 "game.c"
}

static Shape**
game_pick_difficult_shapes (Game* self,
                            gint* result_length1)
{
	Shape** result = NULL;
	gint* metrics = NULL;
	gint* _tmp0_;
	gint metrics_length1;
	gint _metrics_size_;
	gint* possible_types = NULL;
	gint* _tmp41_;
	gint possible_types_length1;
	gint _possible_types_size_;
	gint32 rnd = 0;
	gint* _tmp75_;
	gint _tmp75__length1;
	gint _tmp76_;
	Shape* _tmp77_;
	Shape** shapes = NULL;
	Shape** _tmp78_;
	gint shapes_length1;
	gint _shapes_size_;
	Shape* _tmp79_;
	Shape* _tmp80_;
	Shape* _tmp81_;
	Shape* _tmp82_;
	Shape** _tmp83_;
	gint _tmp83__length1;
#line 544 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 547 "../src/game.vala"
	_tmp0_ = g_new0 (gint, NCOLORS);
#line 547 "../src/game.vala"
	metrics = _tmp0_;
#line 547 "../src/game.vala"
	metrics_length1 = NCOLORS;
#line 547 "../src/game.vala"
	_metrics_size_ = metrics_length1;
#line 1585 "game.c"
	{
		gint type = 0;
#line 548 "../src/game.vala"
		type = 0;
#line 1590 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 548 "../src/game.vala"
			_tmp1_ = TRUE;
#line 548 "../src/game.vala"
			while (TRUE) {
#line 1597 "game.c"
				gint* _tmp3_;
				gint _tmp3__length1;
#line 548 "../src/game.vala"
				if (!_tmp1_) {
#line 1602 "game.c"
					gint _tmp2_;
#line 548 "../src/game.vala"
					_tmp2_ = type;
#line 548 "../src/game.vala"
					type = _tmp2_ + 1;
#line 1608 "game.c"
				}
#line 548 "../src/game.vala"
				_tmp1_ = FALSE;
#line 548 "../src/game.vala"
				if (!(type < NCOLORS)) {
#line 548 "../src/game.vala"
					break;
#line 1616 "game.c"
				}
#line 550 "../src/game.vala"
				_tmp3_ = metrics;
#line 550 "../src/game.vala"
				_tmp3__length1 = metrics_length1;
#line 550 "../src/game.vala"
				_tmp3_[type] = -32000;
#line 1624 "game.c"
				{
					gint rotation = 0;
#line 551 "../src/game.vala"
					rotation = 0;
#line 1629 "game.c"
					{
						gboolean _tmp4_ = FALSE;
#line 551 "../src/game.vala"
						_tmp4_ = TRUE;
#line 551 "../src/game.vala"
						while (TRUE) {
#line 551 "../src/game.vala"
							if (!_tmp4_) {
#line 1638 "game.c"
								gint _tmp5_;
#line 551 "../src/game.vala"
								_tmp5_ = rotation;
#line 551 "../src/game.vala"
								rotation = _tmp5_ + 1;
#line 1644 "game.c"
							}
#line 551 "../src/game.vala"
							_tmp4_ = FALSE;
#line 551 "../src/game.vala"
							if (!(rotation < 4)) {
#line 551 "../src/game.vala"
								break;
#line 1652 "game.c"
							}
							{
								gint pos = 0;
#line 553 "../src/game.vala"
								pos = 0;
#line 1658 "game.c"
								{
									gboolean _tmp6_ = FALSE;
#line 553 "../src/game.vala"
									_tmp6_ = TRUE;
#line 553 "../src/game.vala"
									while (TRUE) {
#line 1665 "game.c"
										gint _tmp8_;
										gint _tmp9_;
										Game* g = NULL;
										Game* _tmp10_;
										Game* _tmp11_;
										Game* _tmp12_;
										Shape* _tmp13_;
										gboolean valid_position = FALSE;
										gint orig_lines = 0;
										Game* _tmp18_;
										Game* _tmp19_;
										gint metric = 0;
										Game* _tmp20_;
										gint* _tmp34_;
										gint _tmp34__length1;
										gint _tmp35_;
										Game* _tmp37_;
#line 553 "../src/game.vala"
										if (!_tmp6_) {
#line 1685 "game.c"
											gint _tmp7_;
#line 553 "../src/game.vala"
											_tmp7_ = pos;
#line 553 "../src/game.vala"
											pos = _tmp7_ + 1;
#line 1691 "game.c"
										}
#line 553 "../src/game.vala"
										_tmp6_ = FALSE;
#line 553 "../src/game.vala"
										_tmp8_ = game_get_width (self);
#line 553 "../src/game.vala"
										_tmp9_ = _tmp8_;
#line 553 "../src/game.vala"
										if (!(pos < _tmp9_)) {
#line 553 "../src/game.vala"
											break;
#line 1703 "game.c"
										}
#line 556 "../src/game.vala"
										_tmp10_ = game_copy (self);
#line 556 "../src/game.vala"
										g = _tmp10_;
#line 557 "../src/game.vala"
										_tmp11_ = g;
#line 557 "../src/game.vala"
										_tmp11_->priv->pick_difficult_blocks = FALSE;
#line 558 "../src/game.vala"
										_tmp12_ = g;
#line 558 "../src/game.vala"
										_tmp13_ = game_make_shape (self, type, rotation);
#line 558 "../src/game.vala"
										_g_object_unref0 (_tmp12_->shape);
#line 558 "../src/game.vala"
										_tmp12_->shape = _tmp13_;
#line 561 "../src/game.vala"
										valid_position = TRUE;
#line 562 "../src/game.vala"
										while (TRUE) {
#line 1725 "game.c"
											Game* _tmp14_;
#line 562 "../src/game.vala"
											_tmp14_ = g;
#line 562 "../src/game.vala"
											if (!game_move_shape (_tmp14_, -1, 0, 0)) {
#line 562 "../src/game.vala"
												break;
#line 1733 "game.c"
											}
										}
										{
											gint x = 0;
#line 563 "../src/game.vala"
											x = 0;
#line 1740 "game.c"
											{
												gboolean _tmp15_ = FALSE;
#line 563 "../src/game.vala"
												_tmp15_ = TRUE;
#line 563 "../src/game.vala"
												while (TRUE) {
#line 1747 "game.c"
													Game* _tmp17_;
#line 563 "../src/game.vala"
													if (!_tmp15_) {
#line 1751 "game.c"
														gint _tmp16_;
#line 563 "../src/game.vala"
														_tmp16_ = x;
#line 563 "../src/game.vala"
														x = _tmp16_ + 1;
#line 1757 "game.c"
													}
#line 563 "../src/game.vala"
													_tmp15_ = FALSE;
#line 563 "../src/game.vala"
													if (!(x < pos)) {
#line 563 "../src/game.vala"
														break;
#line 1765 "game.c"
													}
#line 565 "../src/game.vala"
													_tmp17_ = g;
#line 565 "../src/game.vala"
													if (!game_move_shape (_tmp17_, 1, 0, 0)) {
#line 567 "../src/game.vala"
														valid_position = FALSE;
#line 568 "../src/game.vala"
														break;
#line 1775 "game.c"
													}
												}
											}
										}
#line 572 "../src/game.vala"
										if (!valid_position) {
#line 573 "../src/game.vala"
											_g_object_unref0 (g);
#line 573 "../src/game.vala"
											break;
#line 1786 "game.c"
										}
#line 576 "../src/game.vala"
										_tmp18_ = g;
#line 576 "../src/game.vala"
										orig_lines = _tmp18_->n_lines_destroyed;
#line 577 "../src/game.vala"
										_tmp19_ = g;
#line 577 "../src/game.vala"
										game_drop (_tmp19_);
#line 580 "../src/game.vala"
										_tmp20_ = g;
#line 580 "../src/game.vala"
										metric = (_tmp20_->n_lines_destroyed - orig_lines) * 5000;
#line 1800 "game.c"
										{
											gint x = 0;
#line 583 "../src/game.vala"
											x = 0;
#line 1805 "game.c"
											{
												gboolean _tmp21_ = FALSE;
#line 583 "../src/game.vala"
												_tmp21_ = TRUE;
#line 583 "../src/game.vala"
												while (TRUE) {
#line 1812 "game.c"
													gint _tmp23_;
													gint _tmp24_;
													gint y = 0;
													gint _tmp32_;
													gint _tmp33_;
#line 583 "../src/game.vala"
													if (!_tmp21_) {
#line 1820 "game.c"
														gint _tmp22_;
#line 583 "../src/game.vala"
														_tmp22_ = x;
#line 583 "../src/game.vala"
														x = _tmp22_ + 1;
#line 1826 "game.c"
													}
#line 583 "../src/game.vala"
													_tmp21_ = FALSE;
#line 583 "../src/game.vala"
													_tmp23_ = game_get_width (self);
#line 583 "../src/game.vala"
													_tmp24_ = _tmp23_;
#line 583 "../src/game.vala"
													if (!(x < _tmp24_)) {
#line 583 "../src/game.vala"
														break;
#line 1838 "game.c"
													}
													{
														gboolean _tmp25_ = FALSE;
#line 586 "../src/game.vala"
														y = 0;
#line 586 "../src/game.vala"
														_tmp25_ = TRUE;
#line 586 "../src/game.vala"
														while (TRUE) {
#line 1848 "game.c"
															gint _tmp27_;
															gint _tmp28_;
															Game* _tmp29_;
															Block** _tmp30_;
															gint _tmp30__length1;
															gint _tmp30__length2;
															Block* _tmp31_;
#line 586 "../src/game.vala"
															if (!_tmp25_) {
#line 1858 "game.c"
																gint _tmp26_;
#line 586 "../src/game.vala"
																_tmp26_ = y;
#line 586 "../src/game.vala"
																y = _tmp26_ + 1;
#line 1864 "game.c"
															}
#line 586 "../src/game.vala"
															_tmp25_ = FALSE;
#line 586 "../src/game.vala"
															_tmp27_ = game_get_height (self);
#line 586 "../src/game.vala"
															_tmp28_ = _tmp27_;
#line 586 "../src/game.vala"
															if (!(y < _tmp28_)) {
#line 586 "../src/game.vala"
																break;
#line 1876 "game.c"
															}
#line 588 "../src/game.vala"
															_tmp29_ = g;
#line 588 "../src/game.vala"
															_tmp30_ = _tmp29_->blocks;
#line 588 "../src/game.vala"
															_tmp30__length1 = _tmp29_->blocks_length1;
#line 588 "../src/game.vala"
															_tmp30__length2 = _tmp29_->blocks_length2;
#line 588 "../src/game.vala"
															_tmp31_ = _tmp30_[(x * _tmp30__length2) + y];
#line 588 "../src/game.vala"
															if (_tmp31_ != NULL) {
#line 589 "../src/game.vala"
																break;
#line 1892 "game.c"
															}
														}
													}
#line 592 "../src/game.vala"
													_tmp32_ = game_get_height (self);
#line 592 "../src/game.vala"
													_tmp33_ = _tmp32_;
#line 592 "../src/game.vala"
													metric = metric - (5 * (_tmp33_ - y));
#line 1902 "game.c"
												}
											}
										}
#line 595 "../src/game.vala"
										_tmp34_ = metrics;
#line 595 "../src/game.vala"
										_tmp34__length1 = metrics_length1;
#line 595 "../src/game.vala"
										_tmp35_ = _tmp34_[type];
#line 595 "../src/game.vala"
										if (metric > _tmp35_) {
#line 1914 "game.c"
											gint* _tmp36_;
											gint _tmp36__length1;
#line 596 "../src/game.vala"
											_tmp36_ = metrics;
#line 596 "../src/game.vala"
											_tmp36__length1 = metrics_length1;
#line 596 "../src/game.vala"
											_tmp36_[type] = metric;
#line 1923 "game.c"
										}
#line 599 "../src/game.vala"
										_tmp37_ = g;
#line 599 "../src/game.vala"
										game_stop (_tmp37_);
#line 553 "../src/game.vala"
										_g_object_unref0 (g);
#line 1931 "game.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
#line 605 "../src/game.vala"
		i = 0;
#line 1945 "game.c"
		{
			gboolean _tmp38_ = FALSE;
#line 605 "../src/game.vala"
			_tmp38_ = TRUE;
#line 605 "../src/game.vala"
			while (TRUE) {
#line 1952 "game.c"
				gint* _tmp40_;
				gint _tmp40__length1;
#line 605 "../src/game.vala"
				if (!_tmp38_) {
#line 1957 "game.c"
					gint _tmp39_;
#line 605 "../src/game.vala"
					_tmp39_ = i;
#line 605 "../src/game.vala"
					i = _tmp39_ + 1;
#line 1963 "game.c"
				}
#line 605 "../src/game.vala"
				_tmp38_ = FALSE;
#line 605 "../src/game.vala"
				if (!(i < NCOLORS)) {
#line 605 "../src/game.vala"
					break;
#line 1971 "game.c"
				}
#line 606 "../src/game.vala"
				_tmp40_ = metrics;
#line 606 "../src/game.vala"
				_tmp40__length1 = metrics_length1;
#line 606 "../src/game.vala"
				_tmp40_[i] += (gint) g_random_int_range ((gint32) -2, (gint32) 2);
#line 1979 "game.c"
			}
		}
	}
#line 609 "../src/game.vala"
	_tmp41_ = g_new0 (gint, NCOLORS);
#line 609 "../src/game.vala"
	possible_types = _tmp41_;
#line 609 "../src/game.vala"
	possible_types_length1 = NCOLORS;
#line 609 "../src/game.vala"
	_possible_types_size_ = possible_types_length1;
#line 1991 "game.c"
	{
		gint i = 0;
#line 610 "../src/game.vala"
		i = 0;
#line 1996 "game.c"
		{
			gboolean _tmp42_ = FALSE;
#line 610 "../src/game.vala"
			_tmp42_ = TRUE;
#line 610 "../src/game.vala"
			while (TRUE) {
#line 2003 "game.c"
				gint* _tmp44_;
				gint _tmp44__length1;
#line 610 "../src/game.vala"
				if (!_tmp42_) {
#line 2008 "game.c"
					gint _tmp43_;
#line 610 "../src/game.vala"
					_tmp43_ = i;
#line 610 "../src/game.vala"
					i = _tmp43_ + 1;
#line 2014 "game.c"
				}
#line 610 "../src/game.vala"
				_tmp42_ = FALSE;
#line 610 "../src/game.vala"
				if (!(i < NCOLORS)) {
#line 610 "../src/game.vala"
					break;
#line 2022 "game.c"
				}
#line 611 "../src/game.vala"
				_tmp44_ = possible_types;
#line 611 "../src/game.vala"
				_tmp44__length1 = possible_types_length1;
#line 611 "../src/game.vala"
				_tmp44_[i] = i;
#line 2030 "game.c"
			}
		}
	}
	{
		gint i = 0;
#line 612 "../src/game.vala"
		i = 0;
#line 2038 "game.c"
		{
			gboolean _tmp45_ = FALSE;
#line 612 "../src/game.vala"
			_tmp45_ = TRUE;
#line 612 "../src/game.vala"
			while (TRUE) {
#line 612 "../src/game.vala"
				if (!_tmp45_) {
#line 2047 "game.c"
					gint _tmp46_;
#line 612 "../src/game.vala"
					_tmp46_ = i;
#line 612 "../src/game.vala"
					i = _tmp46_ + 1;
#line 2053 "game.c"
				}
#line 612 "../src/game.vala"
				_tmp45_ = FALSE;
#line 612 "../src/game.vala"
				if (!(i < NCOLORS)) {
#line 612 "../src/game.vala"
					break;
#line 2061 "game.c"
				}
				{
					gint j = 0;
#line 614 "../src/game.vala"
					j = 0;
#line 2067 "game.c"
					{
						gboolean _tmp47_ = FALSE;
#line 614 "../src/game.vala"
						_tmp47_ = TRUE;
#line 614 "../src/game.vala"
						while (TRUE) {
#line 2074 "game.c"
							gint* _tmp49_;
							gint _tmp49__length1;
							gint* _tmp50_;
							gint _tmp50__length1;
							gint _tmp51_;
							gint _tmp52_;
							gint* _tmp53_;
							gint _tmp53__length1;
							gint* _tmp54_;
							gint _tmp54__length1;
							gint _tmp55_;
							gint _tmp56_;
#line 614 "../src/game.vala"
							if (!_tmp47_) {
#line 2089 "game.c"
								gint _tmp48_;
#line 614 "../src/game.vala"
								_tmp48_ = j;
#line 614 "../src/game.vala"
								j = _tmp48_ + 1;
#line 2095 "game.c"
							}
#line 614 "../src/game.vala"
							_tmp47_ = FALSE;
#line 614 "../src/game.vala"
							if (!(j < (NCOLORS - 1))) {
#line 614 "../src/game.vala"
								break;
#line 2103 "game.c"
							}
#line 616 "../src/game.vala"
							_tmp49_ = metrics;
#line 616 "../src/game.vala"
							_tmp49__length1 = metrics_length1;
#line 616 "../src/game.vala"
							_tmp50_ = possible_types;
#line 616 "../src/game.vala"
							_tmp50__length1 = possible_types_length1;
#line 616 "../src/game.vala"
							_tmp51_ = _tmp50_[j];
#line 616 "../src/game.vala"
							_tmp52_ = _tmp49_[_tmp51_];
#line 616 "../src/game.vala"
							_tmp53_ = metrics;
#line 616 "../src/game.vala"
							_tmp53__length1 = metrics_length1;
#line 616 "../src/game.vala"
							_tmp54_ = possible_types;
#line 616 "../src/game.vala"
							_tmp54__length1 = possible_types_length1;
#line 616 "../src/game.vala"
							_tmp55_ = _tmp54_[j + 1];
#line 616 "../src/game.vala"
							_tmp56_ = _tmp53_[_tmp55_];
#line 616 "../src/game.vala"
							if (_tmp52_ > _tmp56_) {
#line 2131 "game.c"
								gint t = 0;
								gint* _tmp57_;
								gint _tmp57__length1;
								gint _tmp58_;
								gint* _tmp59_;
								gint _tmp59__length1;
								gint* _tmp60_;
								gint _tmp60__length1;
								gint _tmp61_;
								gint* _tmp62_;
								gint _tmp62__length1;
#line 618 "../src/game.vala"
								_tmp57_ = possible_types;
#line 618 "../src/game.vala"
								_tmp57__length1 = possible_types_length1;
#line 618 "../src/game.vala"
								_tmp58_ = _tmp57_[j];
#line 618 "../src/game.vala"
								t = _tmp58_;
#line 619 "../src/game.vala"
								_tmp59_ = possible_types;
#line 619 "../src/game.vala"
								_tmp59__length1 = possible_types_length1;
#line 619 "../src/game.vala"
								_tmp60_ = possible_types;
#line 619 "../src/game.vala"
								_tmp60__length1 = possible_types_length1;
#line 619 "../src/game.vala"
								_tmp61_ = _tmp60_[j + 1];
#line 619 "../src/game.vala"
								_tmp59_[j] = _tmp61_;
#line 620 "../src/game.vala"
								_tmp62_ = possible_types;
#line 620 "../src/game.vala"
								_tmp62__length1 = possible_types_length1;
#line 620 "../src/game.vala"
								_tmp62_[j + 1] = t;
#line 2169 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 626 "../src/game.vala"
	rnd = g_random_int_range ((gint32) 0, (gint32) 99);
#line 627 "../src/game.vala"
	if (rnd < ((gint32) 75)) {
#line 2181 "game.c"
		gint* _tmp63_;
		gint _tmp63__length1;
		gint _tmp64_;
		Shape* _tmp65_;
#line 628 "../src/game.vala"
		_tmp63_ = possible_types;
#line 628 "../src/game.vala"
		_tmp63__length1 = possible_types_length1;
#line 628 "../src/game.vala"
		_tmp64_ = _tmp63_[0];
#line 628 "../src/game.vala"
		_tmp65_ = game_make_shape (self, _tmp64_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 628 "../src/game.vala"
		_g_object_unref0 (self->shape);
#line 628 "../src/game.vala"
		self->shape = _tmp65_;
#line 2198 "game.c"
	} else {
#line 629 "../src/game.vala"
		if (rnd < ((gint32) 92)) {
#line 2202 "game.c"
			gint* _tmp66_;
			gint _tmp66__length1;
			gint _tmp67_;
			Shape* _tmp68_;
#line 630 "../src/game.vala"
			_tmp66_ = possible_types;
#line 630 "../src/game.vala"
			_tmp66__length1 = possible_types_length1;
#line 630 "../src/game.vala"
			_tmp67_ = _tmp66_[1];
#line 630 "../src/game.vala"
			_tmp68_ = game_make_shape (self, _tmp67_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 630 "../src/game.vala"
			_g_object_unref0 (self->shape);
#line 630 "../src/game.vala"
			self->shape = _tmp68_;
#line 2219 "game.c"
		} else {
#line 631 "../src/game.vala"
			if (rnd < ((gint32) 98)) {
#line 2223 "game.c"
				gint* _tmp69_;
				gint _tmp69__length1;
				gint _tmp70_;
				Shape* _tmp71_;
#line 632 "../src/game.vala"
				_tmp69_ = possible_types;
#line 632 "../src/game.vala"
				_tmp69__length1 = possible_types_length1;
#line 632 "../src/game.vala"
				_tmp70_ = _tmp69_[2];
#line 632 "../src/game.vala"
				_tmp71_ = game_make_shape (self, _tmp70_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 632 "../src/game.vala"
				_g_object_unref0 (self->shape);
#line 632 "../src/game.vala"
				self->shape = _tmp71_;
#line 2240 "game.c"
			} else {
				gint* _tmp72_;
				gint _tmp72__length1;
				gint _tmp73_;
				Shape* _tmp74_;
#line 634 "../src/game.vala"
				_tmp72_ = possible_types;
#line 634 "../src/game.vala"
				_tmp72__length1 = possible_types_length1;
#line 634 "../src/game.vala"
				_tmp73_ = _tmp72_[3];
#line 634 "../src/game.vala"
				_tmp74_ = game_make_shape (self, _tmp73_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 634 "../src/game.vala"
				_g_object_unref0 (self->shape);
#line 634 "../src/game.vala"
				self->shape = _tmp74_;
#line 2258 "game.c"
			}
		}
	}
#line 637 "../src/game.vala"
	_tmp75_ = possible_types;
#line 637 "../src/game.vala"
	_tmp75__length1 = possible_types_length1;
#line 637 "../src/game.vala"
	_tmp76_ = _tmp75_[NCOLORS - 1];
#line 637 "../src/game.vala"
	_tmp77_ = game_make_shape (self, _tmp76_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 637 "../src/game.vala"
	_g_object_unref0 (self->next_shape);
#line 637 "../src/game.vala"
	self->next_shape = _tmp77_;
#line 639 "../src/game.vala"
	_tmp78_ = g_new0 (Shape*, 2 + 1);
#line 639 "../src/game.vala"
	shapes = _tmp78_;
#line 639 "../src/game.vala"
	shapes_length1 = 2;
#line 639 "../src/game.vala"
	_shapes_size_ = shapes_length1;
#line 640 "../src/game.vala"
	_tmp79_ = self->shape;
#line 640 "../src/game.vala"
	_tmp80_ = _g_object_ref0 (_tmp79_);
#line 640 "../src/game.vala"
	_g_object_unref0 (shapes[0]);
#line 640 "../src/game.vala"
	shapes[0] = _tmp80_;
#line 641 "../src/game.vala"
	_tmp81_ = self->next_shape;
#line 641 "../src/game.vala"
	_tmp82_ = _g_object_ref0 (_tmp81_);
#line 641 "../src/game.vala"
	_g_object_unref0 (shapes[1]);
#line 641 "../src/game.vala"
	shapes[1] = _tmp82_;
#line 642 "../src/game.vala"
	_tmp83_ = shapes;
#line 642 "../src/game.vala"
	_tmp83__length1 = shapes_length1;
#line 642 "../src/game.vala"
	if (result_length1) {
#line 642 "../src/game.vala"
		*result_length1 = _tmp83__length1;
#line 2306 "game.c"
	}
#line 642 "../src/game.vala"
	result = _tmp83_;
#line 642 "../src/game.vala"
	possible_types = (g_free (possible_types), NULL);
#line 642 "../src/game.vala"
	metrics = (g_free (metrics), NULL);
#line 642 "../src/game.vala"
	return result;
#line 2316 "game.c"
}

static Shape*
game_make_shape (Game* self,
                 gint type,
                 gint rotation)
{
	Shape* result = NULL;
	Shape* shape = NULL;
	Shape* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp2_;
	gint offset = 0;
	Shape* _tmp3_;
	Shape* _tmp4_;
	gint min_width = 0;
	gint max_width = 0;
	gint min_height = 0;
	gint max_height = 0;
	gint block_width = 0;
	Shape* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	Shape* _tmp21_;
#line 645 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 647 "../src/game.vala"
	_tmp0_ = shape_new ();
#line 647 "../src/game.vala"
	shape = _tmp0_;
#line 648 "../src/game.vala"
	_tmp1_ = shape;
#line 648 "../src/game.vala"
	_tmp1_->type = type;
#line 649 "../src/game.vala"
	_tmp2_ = shape;
#line 649 "../src/game.vala"
	_tmp2_->rotation = rotation;
#line 652 "../src/game.vala"
	_tmp3_ = shape;
#line 652 "../src/game.vala"
	_tmp4_ = shape;
#line 652 "../src/game.vala"
	offset = (_tmp3_->type * 64) + (_tmp4_->rotation * 16);
#line 653 "../src/game.vala"
	min_width = 4;
#line 653 "../src/game.vala"
	max_width = 0;
#line 653 "../src/game.vala"
	min_height = 4;
#line 653 "../src/game.vala"
	max_height = 0;
#line 2369 "game.c"
	{
		gint x = 0;
#line 654 "../src/game.vala"
		x = 0;
#line 2374 "game.c"
		{
			gboolean _tmp5_ = FALSE;
#line 654 "../src/game.vala"
			_tmp5_ = TRUE;
#line 654 "../src/game.vala"
			while (TRUE) {
#line 654 "../src/game.vala"
				if (!_tmp5_) {
#line 2383 "game.c"
					gint _tmp6_;
#line 654 "../src/game.vala"
					_tmp6_ = x;
#line 654 "../src/game.vala"
					x = _tmp6_ + 1;
#line 2389 "game.c"
				}
#line 654 "../src/game.vala"
				_tmp5_ = FALSE;
#line 654 "../src/game.vala"
				if (!(x < 4)) {
#line 654 "../src/game.vala"
					break;
#line 2397 "game.c"
				}
				{
					gint y = 0;
#line 656 "../src/game.vala"
					y = 0;
#line 2403 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 656 "../src/game.vala"
						_tmp7_ = TRUE;
#line 656 "../src/game.vala"
						while (TRUE) {
#line 2410 "game.c"
							gint _tmp9_;
							Block* b = NULL;
							Block* _tmp10_;
							Block* _tmp11_;
							Shape* _tmp12_;
							Block* _tmp13_;
							Block* _tmp14_;
							Shape* _tmp15_;
							Block* _tmp16_;
							Block* _tmp17_;
#line 656 "../src/game.vala"
							if (!_tmp7_) {
#line 2423 "game.c"
								gint _tmp8_;
#line 656 "../src/game.vala"
								_tmp8_ = y;
#line 656 "../src/game.vala"
								y = _tmp8_ + 1;
#line 2429 "game.c"
							}
#line 656 "../src/game.vala"
							_tmp7_ = FALSE;
#line 656 "../src/game.vala"
							if (!(y < 4)) {
#line 656 "../src/game.vala"
								break;
#line 2437 "game.c"
							}
#line 658 "../src/game.vala"
							_tmp9_ = block_table[(offset + (y * 4)) + x];
#line 658 "../src/game.vala"
							if (_tmp9_ == 0) {
#line 659 "../src/game.vala"
								continue;
#line 2445 "game.c"
							}
#line 661 "../src/game.vala"
							min_width = MIN (x, min_width);
#line 662 "../src/game.vala"
							max_width = MAX (x + 1, max_width);
#line 663 "../src/game.vala"
							min_height = MIN (y, min_height);
#line 664 "../src/game.vala"
							max_height = MAX (y + 1, max_height);
#line 666 "../src/game.vala"
							_tmp10_ = block_new ();
#line 666 "../src/game.vala"
							b = _tmp10_;
#line 667 "../src/game.vala"
							_tmp11_ = b;
#line 667 "../src/game.vala"
							_tmp12_ = shape;
#line 667 "../src/game.vala"
							_tmp11_->color = _tmp12_->type;
#line 668 "../src/game.vala"
							_tmp13_ = b;
#line 668 "../src/game.vala"
							_tmp13_->x = x;
#line 669 "../src/game.vala"
							_tmp14_ = b;
#line 669 "../src/game.vala"
							_tmp14_->y = y;
#line 670 "../src/game.vala"
							_tmp15_ = shape;
#line 670 "../src/game.vala"
							_tmp16_ = b;
#line 670 "../src/game.vala"
							_tmp17_ = _g_object_ref0 (_tmp16_);
#line 670 "../src/game.vala"
							_tmp15_->blocks = g_list_append (_tmp15_->blocks, _tmp17_);
#line 656 "../src/game.vala"
							_g_object_unref0 (b);
#line 2483 "game.c"
						}
					}
				}
			}
		}
	}
#line 673 "../src/game.vala"
	block_width = max_width - min_width;
#line 674 "../src/game.vala"
	_tmp18_ = shape;
#line 674 "../src/game.vala"
	_tmp19_ = game_get_width (self);
#line 674 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 674 "../src/game.vala"
	_tmp18_->x = ((_tmp20_ - block_width) / 2) - min_width;
#line 675 "../src/game.vala"
	_tmp21_ = shape;
#line 675 "../src/game.vala"
	_tmp21_->y = -min_height;
#line 677 "../src/game.vala"
	result = shape;
#line 677 "../src/game.vala"
	return result;
#line 2508 "game.c"
}

static void
game_land_shape (Game* self)
{
	Shape* _tmp0_;
	GList* _tmp1_;
	gint fall_distance = 0;
	gint* lines = NULL;
	gint* _tmp14_;
	gint lines_length1;
	gint _lines_size_;
	gint n_lines = 0;
	gboolean base_line_destroyed = FALSE;
	gint _tmp29_;
	GList* line_blocks = NULL;
	gint old_level = 0;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp77_;
	gint _tmp78_;
	gint* _tmp79_;
	gint _tmp79__length1;
	GList* _tmp80_;
#line 680 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 683 "../src/game.vala"
	_tmp0_ = self->shape;
#line 683 "../src/game.vala"
	_tmp1_ = _tmp0_->blocks;
#line 2539 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 683 "../src/game.vala"
		b_collection = _tmp1_;
#line 683 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 2547 "game.c"
			Block* _tmp2_;
			Block* b = NULL;
#line 683 "../src/game.vala"
			_tmp2_ = _g_object_ref0 ((Block*) b_it->data);
#line 683 "../src/game.vala"
			b = _tmp2_;
#line 2554 "game.c"
			{
				Block* _tmp3_;
				Block* _tmp4_;
				Shape* _tmp5_;
				Block* _tmp6_;
				Block* _tmp7_;
				Shape* _tmp8_;
				Block** _tmp9_;
				gint _tmp9__length1;
				gint _tmp9__length2;
				Block* _tmp10_;
				Block* _tmp11_;
				Block* _tmp12_;
				Block* _tmp13_;
#line 685 "../src/game.vala"
				_tmp3_ = b;
#line 685 "../src/game.vala"
				_tmp4_ = b;
#line 685 "../src/game.vala"
				_tmp5_ = self->shape;
#line 685 "../src/game.vala"
				_tmp4_->x = _tmp4_->x + _tmp5_->x;
#line 686 "../src/game.vala"
				_tmp6_ = b;
#line 686 "../src/game.vala"
				_tmp7_ = b;
#line 686 "../src/game.vala"
				_tmp8_ = self->shape;
#line 686 "../src/game.vala"
				_tmp7_->y = _tmp7_->y + _tmp8_->y;
#line 687 "../src/game.vala"
				_tmp9_ = self->blocks;
#line 687 "../src/game.vala"
				_tmp9__length1 = self->blocks_length1;
#line 687 "../src/game.vala"
				_tmp9__length2 = self->blocks_length2;
#line 687 "../src/game.vala"
				_tmp10_ = b;
#line 687 "../src/game.vala"
				_tmp11_ = b;
#line 687 "../src/game.vala"
				_tmp12_ = b;
#line 687 "../src/game.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 687 "../src/game.vala"
				_g_object_unref0 (_tmp9_[(_tmp10_->x * _tmp9__length2) + _tmp11_->y]);
#line 687 "../src/game.vala"
				_tmp9_[(_tmp10_->x * _tmp9__length2) + _tmp11_->y] = _tmp13_;
#line 683 "../src/game.vala"
				_g_object_unref0 (b);
#line 2605 "game.c"
			}
		}
	}
#line 690 "../src/game.vala"
	fall_distance = 0;
#line 691 "../src/game.vala"
	_tmp14_ = g_new0 (gint, 4);
#line 691 "../src/game.vala"
	lines = _tmp14_;
#line 691 "../src/game.vala"
	lines_length1 = 4;
#line 691 "../src/game.vala"
	_lines_size_ = lines_length1;
#line 692 "../src/game.vala"
	n_lines = 0;
#line 693 "../src/game.vala"
	base_line_destroyed = FALSE;
#line 2623 "game.c"
	{
		gint y = 0;
		gint _tmp15_;
		gint _tmp16_;
#line 694 "../src/game.vala"
		_tmp15_ = game_get_height (self);
#line 694 "../src/game.vala"
		_tmp16_ = _tmp15_;
#line 694 "../src/game.vala"
		y = _tmp16_ - 1;
#line 2634 "game.c"
		{
			gboolean _tmp17_ = FALSE;
#line 694 "../src/game.vala"
			_tmp17_ = TRUE;
#line 694 "../src/game.vala"
			while (TRUE) {
#line 2641 "game.c"
				gboolean explode = FALSE;
#line 694 "../src/game.vala"
				if (!_tmp17_) {
#line 2645 "game.c"
					gint _tmp18_;
#line 694 "../src/game.vala"
					_tmp18_ = y;
#line 694 "../src/game.vala"
					y = _tmp18_ - 1;
#line 2651 "game.c"
				}
#line 694 "../src/game.vala"
				_tmp17_ = FALSE;
#line 694 "../src/game.vala"
				if (!(y >= 0)) {
#line 694 "../src/game.vala"
					break;
#line 2659 "game.c"
				}
#line 696 "../src/game.vala"
				explode = TRUE;
#line 2663 "game.c"
				{
					gint x = 0;
#line 697 "../src/game.vala"
					x = 0;
#line 2668 "game.c"
					{
						gboolean _tmp19_ = FALSE;
#line 697 "../src/game.vala"
						_tmp19_ = TRUE;
#line 697 "../src/game.vala"
						while (TRUE) {
#line 2675 "game.c"
							gint _tmp21_;
							gint _tmp22_;
							Block** _tmp23_;
							gint _tmp23__length1;
							gint _tmp23__length2;
							Block* _tmp24_;
#line 697 "../src/game.vala"
							if (!_tmp19_) {
#line 2684 "game.c"
								gint _tmp20_;
#line 697 "../src/game.vala"
								_tmp20_ = x;
#line 697 "../src/game.vala"
								x = _tmp20_ + 1;
#line 2690 "game.c"
							}
#line 697 "../src/game.vala"
							_tmp19_ = FALSE;
#line 697 "../src/game.vala"
							_tmp21_ = game_get_width (self);
#line 697 "../src/game.vala"
							_tmp22_ = _tmp21_;
#line 697 "../src/game.vala"
							if (!(x < _tmp22_)) {
#line 697 "../src/game.vala"
								break;
#line 2702 "game.c"
							}
#line 699 "../src/game.vala"
							_tmp23_ = self->blocks;
#line 699 "../src/game.vala"
							_tmp23__length1 = self->blocks_length1;
#line 699 "../src/game.vala"
							_tmp23__length2 = self->blocks_length2;
#line 699 "../src/game.vala"
							_tmp24_ = _tmp23_[(x * _tmp23__length2) + y];
#line 699 "../src/game.vala"
							if (_tmp24_ == NULL) {
#line 701 "../src/game.vala"
								explode = FALSE;
#line 702 "../src/game.vala"
								break;
#line 2718 "game.c"
							}
						}
					}
				}
#line 706 "../src/game.vala"
				if (explode) {
#line 2725 "game.c"
					gint _tmp25_;
					gint _tmp26_;
					gint* _tmp27_;
					gint _tmp27__length1;
					gint _tmp28_;
#line 708 "../src/game.vala"
					_tmp25_ = game_get_height (self);
#line 708 "../src/game.vala"
					_tmp26_ = _tmp25_;
#line 708 "../src/game.vala"
					if (y == (_tmp26_ - 1)) {
#line 709 "../src/game.vala"
						base_line_destroyed = TRUE;
#line 2739 "game.c"
					}
#line 710 "../src/game.vala"
					_tmp27_ = lines;
#line 710 "../src/game.vala"
					_tmp27__length1 = lines_length1;
#line 710 "../src/game.vala"
					_tmp27_[n_lines] = y;
#line 711 "../src/game.vala"
					_tmp28_ = n_lines;
#line 711 "../src/game.vala"
					n_lines = _tmp28_ + 1;
#line 2751 "game.c"
				}
			}
		}
	}
#line 714 "../src/game.vala"
	_tmp29_ = n_lines;
#line 714 "../src/game.vala"
	lines = g_renew (gint, lines, n_lines);
#line 714 "../src/game.vala"
	(_tmp29_ > lines_length1) ? memset (lines + lines_length1, 0, sizeof (gint) * (_tmp29_ - lines_length1)) : NULL;
#line 714 "../src/game.vala"
	lines_length1 = _tmp29_;
#line 714 "../src/game.vala"
	_lines_size_ = _tmp29_;
#line 716 "../src/game.vala"
	line_blocks = NULL;
#line 2768 "game.c"
	{
		gint y = 0;
		gint _tmp30_;
		gint _tmp31_;
#line 717 "../src/game.vala"
		_tmp30_ = game_get_height (self);
#line 717 "../src/game.vala"
		_tmp31_ = _tmp30_;
#line 717 "../src/game.vala"
		y = _tmp31_ - 1;
#line 2779 "game.c"
		{
			gboolean _tmp32_ = FALSE;
#line 717 "../src/game.vala"
			_tmp32_ = TRUE;
#line 717 "../src/game.vala"
			while (TRUE) {
#line 2786 "game.c"
				gboolean explode = FALSE;
#line 717 "../src/game.vala"
				if (!_tmp32_) {
#line 2790 "game.c"
					gint _tmp33_;
#line 717 "../src/game.vala"
					_tmp33_ = y;
#line 717 "../src/game.vala"
					y = _tmp33_ - 1;
#line 2796 "game.c"
				}
#line 717 "../src/game.vala"
				_tmp32_ = FALSE;
#line 717 "../src/game.vala"
				if (!(y >= 0)) {
#line 717 "../src/game.vala"
					break;
#line 2804 "game.c"
				}
#line 719 "../src/game.vala"
				explode = TRUE;
#line 2808 "game.c"
				{
					gint x = 0;
#line 720 "../src/game.vala"
					x = 0;
#line 2813 "game.c"
					{
						gboolean _tmp34_ = FALSE;
#line 720 "../src/game.vala"
						_tmp34_ = TRUE;
#line 720 "../src/game.vala"
						while (TRUE) {
#line 2820 "game.c"
							gint _tmp36_;
							gint _tmp37_;
							Block** _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							Block* _tmp39_;
#line 720 "../src/game.vala"
							if (!_tmp34_) {
#line 2829 "game.c"
								gint _tmp35_;
#line 720 "../src/game.vala"
								_tmp35_ = x;
#line 720 "../src/game.vala"
								x = _tmp35_ + 1;
#line 2835 "game.c"
							}
#line 720 "../src/game.vala"
							_tmp34_ = FALSE;
#line 720 "../src/game.vala"
							_tmp36_ = game_get_width (self);
#line 720 "../src/game.vala"
							_tmp37_ = _tmp36_;
#line 720 "../src/game.vala"
							if (!(x < _tmp37_)) {
#line 720 "../src/game.vala"
								break;
#line 2847 "game.c"
							}
#line 722 "../src/game.vala"
							_tmp38_ = self->blocks;
#line 722 "../src/game.vala"
							_tmp38__length1 = self->blocks_length1;
#line 722 "../src/game.vala"
							_tmp38__length2 = self->blocks_length2;
#line 722 "../src/game.vala"
							_tmp39_ = _tmp38_[(x * _tmp38__length2) + y];
#line 722 "../src/game.vala"
							if (_tmp39_ == NULL) {
#line 724 "../src/game.vala"
								explode = FALSE;
#line 725 "../src/game.vala"
								break;
#line 2863 "game.c"
							}
						}
					}
				}
#line 729 "../src/game.vala"
				if (explode) {
#line 2870 "game.c"
					gint _tmp48_;
					{
						gint x = 0;
#line 731 "../src/game.vala"
						x = 0;
#line 2876 "game.c"
						{
							gboolean _tmp40_ = FALSE;
#line 731 "../src/game.vala"
							_tmp40_ = TRUE;
#line 731 "../src/game.vala"
							while (TRUE) {
#line 2883 "game.c"
								gint _tmp42_;
								gint _tmp43_;
								Block** _tmp44_;
								gint _tmp44__length1;
								gint _tmp44__length2;
								Block* _tmp45_;
								Block* _tmp46_;
								Block** _tmp47_;
								gint _tmp47__length1;
								gint _tmp47__length2;
#line 731 "../src/game.vala"
								if (!_tmp40_) {
#line 2896 "game.c"
									gint _tmp41_;
#line 731 "../src/game.vala"
									_tmp41_ = x;
#line 731 "../src/game.vala"
									x = _tmp41_ + 1;
#line 2902 "game.c"
								}
#line 731 "../src/game.vala"
								_tmp40_ = FALSE;
#line 731 "../src/game.vala"
								_tmp42_ = game_get_width (self);
#line 731 "../src/game.vala"
								_tmp43_ = _tmp42_;
#line 731 "../src/game.vala"
								if (!(x < _tmp43_)) {
#line 731 "../src/game.vala"
									break;
#line 2914 "game.c"
								}
#line 733 "../src/game.vala"
								_tmp44_ = self->blocks;
#line 733 "../src/game.vala"
								_tmp44__length1 = self->blocks_length1;
#line 733 "../src/game.vala"
								_tmp44__length2 = self->blocks_length2;
#line 733 "../src/game.vala"
								_tmp45_ = _tmp44_[(x * _tmp44__length2) + y];
#line 733 "../src/game.vala"
								_tmp46_ = _g_object_ref0 (_tmp45_);
#line 733 "../src/game.vala"
								line_blocks = g_list_append (line_blocks, _tmp46_);
#line 734 "../src/game.vala"
								_tmp47_ = self->blocks;
#line 734 "../src/game.vala"
								_tmp47__length1 = self->blocks_length1;
#line 734 "../src/game.vala"
								_tmp47__length2 = self->blocks_length2;
#line 734 "../src/game.vala"
								_g_object_unref0 (_tmp47_[(x * _tmp47__length2) + y]);
#line 734 "../src/game.vala"
								_tmp47_[(x * _tmp47__length2) + y] = NULL;
#line 2938 "game.c"
							}
						}
					}
#line 736 "../src/game.vala"
					_tmp48_ = fall_distance;
#line 736 "../src/game.vala"
					fall_distance = _tmp48_ + 1;
#line 2946 "game.c"
				} else {
#line 738 "../src/game.vala"
					if (fall_distance > 0) {
#line 2950 "game.c"
						{
							gint x = 0;
#line 740 "../src/game.vala"
							x = 0;
#line 2955 "game.c"
							{
								gboolean _tmp49_ = FALSE;
#line 740 "../src/game.vala"
								_tmp49_ = TRUE;
#line 740 "../src/game.vala"
								while (TRUE) {
#line 2962 "game.c"
									gint _tmp51_;
									gint _tmp52_;
									Block* b = NULL;
									Block** _tmp53_;
									gint _tmp53__length1;
									gint _tmp53__length2;
									Block* _tmp54_;
									Block* _tmp55_;
									Block* _tmp56_;
#line 740 "../src/game.vala"
									if (!_tmp49_) {
#line 2974 "game.c"
										gint _tmp50_;
#line 740 "../src/game.vala"
										_tmp50_ = x;
#line 740 "../src/game.vala"
										x = _tmp50_ + 1;
#line 2980 "game.c"
									}
#line 740 "../src/game.vala"
									_tmp49_ = FALSE;
#line 740 "../src/game.vala"
									_tmp51_ = game_get_width (self);
#line 740 "../src/game.vala"
									_tmp52_ = _tmp51_;
#line 740 "../src/game.vala"
									if (!(x < _tmp52_)) {
#line 740 "../src/game.vala"
										break;
#line 2992 "game.c"
									}
#line 742 "../src/game.vala"
									_tmp53_ = self->blocks;
#line 742 "../src/game.vala"
									_tmp53__length1 = self->blocks_length1;
#line 742 "../src/game.vala"
									_tmp53__length2 = self->blocks_length2;
#line 742 "../src/game.vala"
									_tmp54_ = _tmp53_[(x * _tmp53__length2) + y];
#line 742 "../src/game.vala"
									_tmp55_ = _g_object_ref0 (_tmp54_);
#line 742 "../src/game.vala"
									b = _tmp55_;
#line 743 "../src/game.vala"
									_tmp56_ = b;
#line 743 "../src/game.vala"
									if (_tmp56_ != NULL) {
#line 3010 "game.c"
										Block* _tmp57_;
										Block* _tmp58_;
										Block** _tmp59_;
										gint _tmp59__length1;
										gint _tmp59__length2;
										Block* _tmp60_;
										Block* _tmp61_;
										Block* _tmp62_;
										Block* _tmp63_;
										Block** _tmp64_;
										gint _tmp64__length1;
										gint _tmp64__length2;
#line 745 "../src/game.vala"
										_tmp57_ = b;
#line 745 "../src/game.vala"
										_tmp58_ = b;
#line 745 "../src/game.vala"
										_tmp58_->y = _tmp58_->y + fall_distance;
#line 746 "../src/game.vala"
										_tmp59_ = self->blocks;
#line 746 "../src/game.vala"
										_tmp59__length1 = self->blocks_length1;
#line 746 "../src/game.vala"
										_tmp59__length2 = self->blocks_length2;
#line 746 "../src/game.vala"
										_tmp60_ = b;
#line 746 "../src/game.vala"
										_tmp61_ = b;
#line 746 "../src/game.vala"
										_tmp62_ = b;
#line 746 "../src/game.vala"
										_tmp63_ = _g_object_ref0 (_tmp62_);
#line 746 "../src/game.vala"
										_g_object_unref0 (_tmp59_[(_tmp60_->x * _tmp59__length2) + _tmp61_->y]);
#line 746 "../src/game.vala"
										_tmp59_[(_tmp60_->x * _tmp59__length2) + _tmp61_->y] = _tmp63_;
#line 747 "../src/game.vala"
										_tmp64_ = self->blocks;
#line 747 "../src/game.vala"
										_tmp64__length1 = self->blocks_length1;
#line 747 "../src/game.vala"
										_tmp64__length2 = self->blocks_length2;
#line 747 "../src/game.vala"
										_g_object_unref0 (_tmp64_[(x * _tmp64__length2) + y]);
#line 747 "../src/game.vala"
										_tmp64_[(x * _tmp64__length2) + y] = NULL;
#line 3057 "game.c"
									}
#line 740 "../src/game.vala"
									_g_object_unref0 (b);
#line 3061 "game.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 753 "../src/game.vala"
	_tmp65_ = game_get_level (self);
#line 753 "../src/game.vala"
	_tmp66_ = _tmp65_;
#line 753 "../src/game.vala"
	old_level = _tmp66_;
#line 756 "../src/game.vala"
	self->n_lines_destroyed = self->n_lines_destroyed + n_lines;
#line 757 "../src/game.vala"
	switch (n_lines) {
#line 757 "../src/game.vala"
		case 0:
#line 3082 "game.c"
		{
#line 760 "../src/game.vala"
			break;
#line 3086 "game.c"
		}
#line 757 "../src/game.vala"
		case 1:
#line 3090 "game.c"
		{
			gint _tmp67_;
			gint _tmp68_;
#line 762 "../src/game.vala"
			_tmp67_ = game_get_level (self);
#line 762 "../src/game.vala"
			_tmp68_ = _tmp67_;
#line 762 "../src/game.vala"
			self->score = self->score + (40 * _tmp68_);
#line 763 "../src/game.vala"
			break;
#line 3102 "game.c"
		}
#line 757 "../src/game.vala"
		case 2:
#line 3106 "game.c"
		{
			gint _tmp69_;
			gint _tmp70_;
#line 765 "../src/game.vala"
			_tmp69_ = game_get_level (self);
#line 765 "../src/game.vala"
			_tmp70_ = _tmp69_;
#line 765 "../src/game.vala"
			self->score = self->score + (100 * _tmp70_);
#line 766 "../src/game.vala"
			break;
#line 3118 "game.c"
		}
#line 757 "../src/game.vala"
		case 3:
#line 3122 "game.c"
		{
			gint _tmp71_;
			gint _tmp72_;
#line 768 "../src/game.vala"
			_tmp71_ = game_get_level (self);
#line 768 "../src/game.vala"
			_tmp72_ = _tmp71_;
#line 768 "../src/game.vala"
			self->score = self->score + (300 * _tmp72_);
#line 769 "../src/game.vala"
			break;
#line 3134 "game.c"
		}
#line 757 "../src/game.vala"
		case 4:
#line 3138 "game.c"
		{
			gint _tmp73_;
			gint _tmp74_;
#line 771 "../src/game.vala"
			_tmp73_ = game_get_level (self);
#line 771 "../src/game.vala"
			_tmp74_ = _tmp73_;
#line 771 "../src/game.vala"
			self->score = self->score + (1200 * _tmp74_);
#line 772 "../src/game.vala"
			break;
#line 3150 "game.c"
		}
		default:
#line 757 "../src/game.vala"
		break;
#line 3155 "game.c"
	}
#line 775 "../src/game.vala"
	if (base_line_destroyed) {
#line 3159 "game.c"
		gint _tmp75_;
		gint _tmp76_;
#line 776 "../src/game.vala"
		_tmp75_ = game_get_level (self);
#line 776 "../src/game.vala"
		_tmp76_ = _tmp75_;
#line 776 "../src/game.vala"
		self->score = self->score + (10000 * _tmp76_);
#line 3168 "game.c"
	}
#line 779 "../src/game.vala"
	_tmp77_ = game_get_level (self);
#line 779 "../src/game.vala"
	_tmp78_ = _tmp77_;
#line 779 "../src/game.vala"
	if (_tmp78_ != old_level) {
#line 780 "../src/game.vala"
		game_setup_drop_timer (self);
#line 3178 "game.c"
	}
#line 782 "../src/game.vala"
	_tmp79_ = lines;
#line 782 "../src/game.vala"
	_tmp79__length1 = lines_length1;
#line 782 "../src/game.vala"
	_tmp80_ = line_blocks;
#line 782 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_SHAPE_LANDED_SIGNAL], 0, _tmp79_, (gint) _tmp79__length1, _tmp80_);
#line 783 "../src/game.vala"
	_g_object_unref0 (self->shape);
#line 783 "../src/game.vala"
	self->shape = NULL;
#line 680 "../src/game.vala"
	(line_blocks == NULL) ? NULL : (line_blocks = (_g_list_free__g_object_unref0_ (line_blocks), NULL));
#line 680 "../src/game.vala"
	lines = (g_free (lines), NULL);
#line 3196 "game.c"
}

static gboolean
game_move_shape (Game* self,
                 gint x_step,
                 gint y_step,
                 gint r_step)
{
	gboolean result = FALSE;
	Shape* _tmp0_;
	gboolean can_move = FALSE;
	Shape* _tmp1_;
	GList* _tmp2_;
#line 786 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 788 "../src/game.vala"
	_tmp0_ = self->shape;
#line 788 "../src/game.vala"
	if (_tmp0_ == NULL) {
#line 789 "../src/game.vala"
		result = FALSE;
#line 789 "../src/game.vala"
		return result;
#line 3220 "game.c"
	}
#line 792 "../src/game.vala"
	game_rotate_shape (self, r_step);
#line 793 "../src/game.vala"
	can_move = TRUE;
#line 794 "../src/game.vala"
	_tmp1_ = self->shape;
#line 794 "../src/game.vala"
	_tmp2_ = _tmp1_->blocks;
#line 3230 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 794 "../src/game.vala"
		b_collection = _tmp2_;
#line 794 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 3238 "game.c"
			Block* _tmp3_;
			Block* b = NULL;
#line 794 "../src/game.vala"
			_tmp3_ = _g_object_ref0 ((Block*) b_it->data);
#line 794 "../src/game.vala"
			b = _tmp3_;
#line 3245 "game.c"
			{
				gint x = 0;
				Shape* _tmp4_;
				Block* _tmp5_;
				gint y = 0;
				Shape* _tmp6_;
				Block* _tmp7_;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 796 "../src/game.vala"
				_tmp4_ = self->shape;
#line 796 "../src/game.vala"
				_tmp5_ = b;
#line 796 "../src/game.vala"
				x = (_tmp4_->x + x_step) + _tmp5_->x;
#line 797 "../src/game.vala"
				_tmp6_ = self->shape;
#line 797 "../src/game.vala"
				_tmp7_ = b;
#line 797 "../src/game.vala"
				y = (_tmp6_->y + y_step) + _tmp7_->y;
#line 798 "../src/game.vala"
				if (x < 0) {
#line 798 "../src/game.vala"
					_tmp10_ = TRUE;
#line 3272 "game.c"
				} else {
					gint _tmp11_;
					gint _tmp12_;
#line 798 "../src/game.vala"
					_tmp11_ = game_get_width (self);
#line 798 "../src/game.vala"
					_tmp12_ = _tmp11_;
#line 798 "../src/game.vala"
					_tmp10_ = x >= _tmp12_;
#line 3282 "game.c"
				}
#line 798 "../src/game.vala"
				if (_tmp10_) {
#line 798 "../src/game.vala"
					_tmp9_ = TRUE;
#line 3288 "game.c"
				} else {
					gint _tmp13_;
					gint _tmp14_;
#line 798 "../src/game.vala"
					_tmp13_ = game_get_height (self);
#line 798 "../src/game.vala"
					_tmp14_ = _tmp13_;
#line 798 "../src/game.vala"
					_tmp9_ = y >= _tmp14_;
#line 3298 "game.c"
				}
#line 798 "../src/game.vala"
				if (_tmp9_) {
#line 798 "../src/game.vala"
					_tmp8_ = TRUE;
#line 3304 "game.c"
				} else {
					Block** _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					Block* _tmp16_;
#line 798 "../src/game.vala"
					_tmp15_ = self->blocks;
#line 798 "../src/game.vala"
					_tmp15__length1 = self->blocks_length1;
#line 798 "../src/game.vala"
					_tmp15__length2 = self->blocks_length2;
#line 798 "../src/game.vala"
					_tmp16_ = _tmp15_[(x * _tmp15__length2) + y];
#line 798 "../src/game.vala"
					_tmp8_ = _tmp16_ != NULL;
#line 3320 "game.c"
				}
#line 798 "../src/game.vala"
				if (_tmp8_) {
#line 800 "../src/game.vala"
					can_move = FALSE;
#line 801 "../src/game.vala"
					_g_object_unref0 (b);
#line 801 "../src/game.vala"
					break;
#line 3330 "game.c"
				}
#line 794 "../src/game.vala"
				_g_object_unref0 (b);
#line 3334 "game.c"
			}
		}
	}
#line 806 "../src/game.vala"
	if (can_move) {
#line 3340 "game.c"
		Shape* _tmp17_;
		Shape* _tmp18_;
		Shape* _tmp19_;
		Shape* _tmp20_;
#line 808 "../src/game.vala"
		_tmp17_ = self->shape;
#line 808 "../src/game.vala"
		_tmp18_ = self->shape;
#line 808 "../src/game.vala"
		_tmp18_->x = _tmp18_->x + x_step;
#line 809 "../src/game.vala"
		_tmp19_ = self->shape;
#line 809 "../src/game.vala"
		_tmp20_ = self->shape;
#line 809 "../src/game.vala"
		_tmp20_->y = _tmp20_->y + y_step;
#line 811 "../src/game.vala"
		if (x_step != 0) {
#line 812 "../src/game.vala"
			g_signal_emit (self, game_signals[GAME_SHAPE_MOVED_SIGNAL], 0);
#line 3361 "game.c"
		} else {
#line 813 "../src/game.vala"
			if (y_step > 0) {
#line 814 "../src/game.vala"
				g_signal_emit (self, game_signals[GAME_SHAPE_DROPPED_SIGNAL], 0);
#line 3367 "game.c"
			} else {
#line 816 "../src/game.vala"
				g_signal_emit (self, game_signals[GAME_SHAPE_ROTATED_SIGNAL], 0);
#line 3371 "game.c"
			}
		}
	} else {
#line 819 "../src/game.vala"
		game_rotate_shape (self, -r_step);
#line 3377 "game.c"
	}
#line 821 "../src/game.vala"
	result = can_move;
#line 821 "../src/game.vala"
	return result;
#line 3383 "game.c"
}

static void
game_rotate_shape (Game* self,
                   gint r_step)
{
	gint r = 0;
	Shape* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp2_;
	GList* b = NULL;
	Shape* _tmp3_;
	GList* _tmp4_;
	gint offset = 0;
	Shape* _tmp5_;
#line 824 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 826 "../src/game.vala"
	_tmp0_ = self->shape;
#line 826 "../src/game.vala"
	r = _tmp0_->rotation + r_step;
#line 827 "../src/game.vala"
	if (r < 0) {
#line 828 "../src/game.vala"
		r = r + 4;
#line 3409 "game.c"
	}
#line 829 "../src/game.vala"
	if (r >= 4) {
#line 830 "../src/game.vala"
		r = r - 4;
#line 3415 "game.c"
	}
#line 832 "../src/game.vala"
	_tmp1_ = self->shape;
#line 832 "../src/game.vala"
	if (r == _tmp1_->rotation) {
#line 833 "../src/game.vala"
		return;
#line 3423 "game.c"
	}
#line 834 "../src/game.vala"
	_tmp2_ = self->shape;
#line 834 "../src/game.vala"
	_tmp2_->rotation = r;
#line 837 "../src/game.vala"
	_tmp3_ = self->shape;
#line 837 "../src/game.vala"
	_tmp4_ = _tmp3_->blocks;
#line 837 "../src/game.vala"
	b = _tmp4_;
#line 838 "../src/game.vala"
	_tmp5_ = self->shape;
#line 838 "../src/game.vala"
	offset = (_tmp5_->type * 64) + (r * 16);
#line 3439 "game.c"
	{
		gint x = 0;
#line 839 "../src/game.vala"
		x = 0;
#line 3444 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 839 "../src/game.vala"
			_tmp6_ = TRUE;
#line 839 "../src/game.vala"
			while (TRUE) {
#line 839 "../src/game.vala"
				if (!_tmp6_) {
#line 3453 "game.c"
					gint _tmp7_;
#line 839 "../src/game.vala"
					_tmp7_ = x;
#line 839 "../src/game.vala"
					x = _tmp7_ + 1;
#line 3459 "game.c"
				}
#line 839 "../src/game.vala"
				_tmp6_ = FALSE;
#line 839 "../src/game.vala"
				if (!(x < 4)) {
#line 839 "../src/game.vala"
					break;
#line 3467 "game.c"
				}
				{
					gint y = 0;
#line 841 "../src/game.vala"
					y = 0;
#line 3473 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 841 "../src/game.vala"
						_tmp8_ = TRUE;
#line 841 "../src/game.vala"
						while (TRUE) {
#line 3480 "game.c"
							gint _tmp10_;
#line 841 "../src/game.vala"
							if (!_tmp8_) {
#line 3484 "game.c"
								gint _tmp9_;
#line 841 "../src/game.vala"
								_tmp9_ = y;
#line 841 "../src/game.vala"
								y = _tmp9_ + 1;
#line 3490 "game.c"
							}
#line 841 "../src/game.vala"
							_tmp8_ = FALSE;
#line 841 "../src/game.vala"
							if (!(y < 4)) {
#line 841 "../src/game.vala"
								break;
#line 3498 "game.c"
							}
#line 843 "../src/game.vala"
							_tmp10_ = block_table[(offset + (y * 4)) + x];
#line 843 "../src/game.vala"
							if (_tmp10_ != 0) {
#line 3504 "game.c"
								GList* _tmp11_;
								gconstpointer _tmp12_;
								GList* _tmp13_;
								gconstpointer _tmp14_;
								GList* _tmp15_;
								GList* _tmp16_;
#line 845 "../src/game.vala"
								_tmp11_ = b;
#line 845 "../src/game.vala"
								_tmp12_ = _tmp11_->data;
#line 845 "../src/game.vala"
								((Block*) _tmp12_)->x = x;
#line 846 "../src/game.vala"
								_tmp13_ = b;
#line 846 "../src/game.vala"
								_tmp14_ = _tmp13_->data;
#line 846 "../src/game.vala"
								((Block*) _tmp14_)->y = y;
#line 847 "../src/game.vala"
								_tmp15_ = b;
#line 847 "../src/game.vala"
								_tmp16_ = _tmp15_->next;
#line 847 "../src/game.vala"
								b = _tmp16_;
#line 3529 "game.c"
							}
						}
					}
				}
			}
		}
	}
}

gint
game_get_width (Game* self)
{
	gint result;
	Block** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
#line 230 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "../src/game.vala"
	_tmp0_ = self->blocks;
#line 230 "../src/game.vala"
	_tmp0__length1 = self->blocks_length1;
#line 230 "../src/game.vala"
	_tmp0__length2 = self->blocks_length2;
#line 230 "../src/game.vala"
	_tmp1_ = _tmp0__length1;
#line 230 "../src/game.vala"
	result = _tmp1_;
#line 230 "../src/game.vala"
	return result;
#line 3561 "game.c"
}

gint
game_get_height (Game* self)
{
	gint result;
	Block** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
#line 231 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 231 "../src/game.vala"
	_tmp0_ = self->blocks;
#line 231 "../src/game.vala"
	_tmp0__length1 = self->blocks_length1;
#line 231 "../src/game.vala"
	_tmp0__length2 = self->blocks_length2;
#line 231 "../src/game.vala"
	_tmp1_ = _tmp0__length2;
#line 231 "../src/game.vala"
	result = _tmp1_;
#line 231 "../src/game.vala"
	return result;
#line 3586 "game.c"
}

gint
game_get_level (Game* self)
{
	gint result;
#line 246 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 246 "../src/game.vala"
	result = self->priv->starting_level + (self->n_lines_destroyed / 10);
#line 246 "../src/game.vala"
	return result;
#line 3599 "game.c"
}

gboolean
game_get_paused (Game* self)
{
	gboolean result;
#line 267 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "../src/game.vala"
	result = self->priv->_paused;
#line 267 "../src/game.vala"
	return result;
#line 3612 "game.c"
}

void
game_set_paused (Game* self,
                 gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 268 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/game.vala"
	self->priv->_paused = value;
#line 271 "../src/game.vala"
	if (self->priv->has_started) {
#line 271 "../src/game.vala"
		_tmp0_ = !self->game_over;
#line 3628 "game.c"
	} else {
#line 271 "../src/game.vala"
		_tmp0_ = FALSE;
#line 3632 "game.c"
	}
#line 271 "../src/game.vala"
	if (_tmp0_) {
#line 272 "../src/game.vala"
		game_setup_drop_timer (self);
#line 3638 "game.c"
	}
#line 273 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_PAUSE_CHANGED_SIGNAL], 0);
#line 268 "../src/game.vala"
	g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_PAUSED_PROPERTY]);
#line 3644 "game.c"
}

gint
game_get_shadow_y (Game* self)
{
	gint result;
	Shape* _tmp0_;
	gint d = 0;
	Game* g = NULL;
	Game* _tmp1_;
	Shape* _tmp4_;
#line 280 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 282 "../src/game.vala"
	_tmp0_ = self->shape;
#line 282 "../src/game.vala"
	if (_tmp0_ == NULL) {
#line 283 "../src/game.vala"
		result = 0;
#line 283 "../src/game.vala"
		return result;
#line 3666 "game.c"
	}
#line 285 "../src/game.vala"
	d = 0;
#line 286 "../src/game.vala"
	_tmp1_ = game_copy (self);
#line 286 "../src/game.vala"
	g = _tmp1_;
#line 287 "../src/game.vala"
	while (TRUE) {
#line 3676 "game.c"
		Game* _tmp2_;
		gint _tmp3_;
#line 287 "../src/game.vala"
		_tmp2_ = g;
#line 287 "../src/game.vala"
		if (!game_move_shape (_tmp2_, 0, 1, 0)) {
#line 287 "../src/game.vala"
			break;
#line 3685 "game.c"
		}
#line 288 "../src/game.vala"
		_tmp3_ = d;
#line 288 "../src/game.vala"
		d = _tmp3_ + 1;
#line 3691 "game.c"
	}
#line 290 "../src/game.vala"
	_tmp4_ = self->shape;
#line 290 "../src/game.vala"
	result = _tmp4_->y + d;
#line 290 "../src/game.vala"
	_g_object_unref0 (g);
#line 290 "../src/game.vala"
	return result;
#line 3701 "game.c"
}

static void
g_cclosure_user_marshal_VOID__POINTER_INT_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT_POINTER) (gpointer data1, gpointer arg_1, gint arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 219 "../src/game.vala"
	g_return_if_fail (n_param_values == 4);
#line 219 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 219 "../src/game.vala"
		data1 = closure->data;
#line 219 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 3726 "game.c"
	} else {
#line 219 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 219 "../src/game.vala"
		data2 = closure->data;
#line 3732 "game.c"
	}
#line 219 "../src/game.vala"
	callback = (GMarshalFunc_VOID__POINTER_INT_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 219 "../src/game.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), g_value_get_pointer (param_values + 3), data2);
#line 3738 "game.c"
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 219 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 219 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_WIDTH_PROPERTY, game_properties[GAME_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HEIGHT_PROPERTY, game_properties[GAME_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_LEVEL_PROPERTY, game_properties[GAME_LEVEL_PROPERTY] = g_param_spec_int ("level", "level", "level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_PAUSED_PROPERTY, game_properties[GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SHADOW_Y_PROPERTY, game_properties[GAME_SHADOW_Y_PROPERTY] = g_param_spec_int ("shadow-y", "shadow-y", "shadow-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	game_signals[GAME_STARTED_SIGNAL] = g_signal_new ("started", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_ADDED_SIGNAL] = g_signal_new ("shape-added", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_MOVED_SIGNAL] = g_signal_new ("shape-moved", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_DROPPED_SIGNAL] = g_signal_new ("shape-dropped", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_ROTATED_SIGNAL] = g_signal_new ("shape-rotated", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_LANDED_SIGNAL] = g_signal_new ("shape-landed", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT_POINTER, G_TYPE_NONE, 3, G_TYPE_POINTER, G_TYPE_INT, G_TYPE_POINTER);
#line 219 "../src/game.vala"
	game_signals[GAME_PAUSE_CHANGED_SIGNAL] = g_signal_new ("pause-changed", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_COMPLETE_SIGNAL] = g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3781 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
#line 219 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 222 "../src/game.vala"
	self->shape = NULL;
#line 225 "../src/game.vala"
	self->next_shape = NULL;
#line 234 "../src/game.vala"
	self->n_lines_destroyed = 0;
#line 237 "../src/game.vala"
	self->score = 0;
#line 240 "../src/game.vala"
	self->priv->starting_level = 1;
#line 243 "../src/game.vala"
	self->priv->pick_difficult_blocks = FALSE;
#line 249 "../src/game.vala"
	self->priv->fast_move_direction = 0;
#line 252 "../src/game.vala"
	self->priv->fast_move_timeout = (guint) 0;
#line 255 "../src/game.vala"
	self->priv->fast_forward = FALSE;
#line 258 "../src/game.vala"
	self->priv->drop_timeout = (guint) 0;
#line 261 "../src/game.vala"
	self->priv->has_started = FALSE;
#line 264 "../src/game.vala"
	self->priv->_paused = FALSE;
#line 294 "../src/game.vala"
	self->game_over = FALSE;
#line 3816 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 219 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 222 "../src/game.vala"
	_g_object_unref0 (self->shape);
#line 225 "../src/game.vala"
	_g_object_unref0 (self->next_shape);
#line 228 "../src/game.vala"
	self->blocks = (_vala_array_free (self->blocks, self->blocks_length1 * self->blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 3833 "game.c"
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 219 "../src/game.vala"
	switch (property_id) {
#line 219 "../src/game.vala"
		case GAME_WIDTH_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_width (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_HEIGHT_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_height (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_LEVEL_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_level (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_PAUSED_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_boolean (value, game_get_paused (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_SHADOW_Y_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_shadow_y (self));
#line 219 "../src/game.vala"
		break;
#line 3890 "game.c"
		default:
#line 219 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 219 "../src/game.vala"
		break;
#line 3896 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 219 "../src/game.vala"
	switch (property_id) {
#line 219 "../src/game.vala"
		case GAME_PAUSED_PROPERTY:
#line 219 "../src/game.vala"
		game_set_paused (self, g_value_get_boolean (value));
#line 219 "../src/game.vala"
		break;
#line 3916 "game.c"
		default:
#line 219 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 219 "../src/game.vala"
		break;
#line 3922 "game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

